/**
 * vis-data
 * http://visjs.org/
 *
 * Manage unstructured data using DataSet. Add, update, and remove data, and listen for changes in the data.
 *
 * @version 7.1.1
 * @date    2020-11-15T19:08:22.864Z
 *
 * @copyright (c) 2011-2017 Almende B.V, http://almende.com
 * @copyright (c) 2017-2019 visjs contributors, https://github.com/visjs
 *
 * @license
 * vis.js is dual licensed under both
 *
 *   1. The Apache 2.0 License
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *   and
 *
 *   2. The MIT License
 *      http://opensource.org/licenses/MIT
 *
 * vis.js may be distributed under either license.
 */
var t="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};function e(t,e,r){return t(r={path:e,exports:{},require:function(t,e){return function(){throw new Error("Dynamic requires are not currently supported by @rollup/plugin-commonjs")}(null==e&&r.path)}},r.exports),r.exports}var r=function(t){return t&&t.Math==Math&&t},n=r("object"==typeof globalThis&&globalThis)||r("object"==typeof window&&window)||r("object"==typeof self&&self)||r("object"==typeof t&&t)||function(){return this}()||Function("return this")(),o=function(t){try{return!!t()}catch(t){return!0}},i=!o((function(){return 7!=Object.defineProperty({},1,{get:function(){return 7}})[1]})),a={}.propertyIsEnumerable,u=Object.getOwnPropertyDescriptor,c={f:u&&!a.call({1:2},1)?function(t){var e=u(this,t);return!!e&&e.enumerable}:a},s=function(t,e){return{enumerable:!(1&t),configurable:!(2&t),writable:!(4&t),value:e}},f={}.toString,l=function(t){return f.call(t).slice(8,-1)},h="".split,p=o((function(){return!Object("z").propertyIsEnumerable(0)}))?function(t){return"String"==l(t)?h.call(t,""):Object(t)}:Object,v=function(t){if(null==t)throw TypeError("Can't call method on "+t);return t},d=function(t){return p(v(t))},y=function(t){return"object"==typeof t?null!==t:"function"==typeof t},g=function(t,e){if(!y(t))return t;var r,n;if(e&&"function"==typeof(r=t.toString)&&!y(n=r.call(t)))return n;if("function"==typeof(r=t.valueOf)&&!y(n=r.call(t)))return n;if(!e&&"function"==typeof(r=t.toString)&&!y(n=r.call(t)))return n;throw TypeError("Can't convert object to primitive value")},m={}.hasOwnProperty,b=function(t,e){return m.call(t,e)},_=n.document,w=y(_)&&y(_.createElement),O=function(t){return w?_.createElement(t):{}},x=!i&&!o((function(){return 7!=Object.defineProperty(O("div"),"a",{get:function(){return 7}}).a})),S=Object.getOwnPropertyDescriptor,k={f:i?S:function(t,e){if(t=d(t),e=g(e,!0),x)try{return S(t,e)}catch(t){}if(b(t,e))return s(!c.f.call(t,e),t[e])}},A=/#|\.prototype\./,j=function(t,e){var r=I[E(t)];return r==T||r!=P&&("function"==typeof e?o(e):!!e)},E=j.normalize=function(t){return String(t).replace(A,".").toLowerCase()},I=j.data={},P=j.NATIVE="N",T=j.POLYFILL="P",D=j,L={},C=function(t){if("function"!=typeof t)throw TypeError(String(t)+" is not a function");return t},R=function(t,e,r){if(C(t),void 0===e)return t;switch(r){case 0:return function(){return t.call(e)};case 1:return function(r){return t.call(e,r)};case 2:return function(r,n){return t.call(e,r,n)};case 3:return function(r,n,o){return t.call(e,r,n,o)}}return function(){return t.apply(e,arguments)}},M=function(t){if(!y(t))throw TypeError(String(t)+" is not an object");return t},F=Object.defineProperty,N={f:i?F:function(t,e,r){if(M(t),e=g(e,!0),M(r),x)try{return F(t,e,r)}catch(t){}if("get"in r||"set"in r)throw TypeError("Accessors not supported");return"value"in r&&(t[e]=r.value),t}},q=i?function(t,e,r){return N.f(t,e,s(1,r))}:function(t,e,r){return t[e]=r,t},G=k.f,z=function(t){var e=function(e,r,n){if(this instanceof t){switch(arguments.length){case 0:return new t;case 1:return new t(e);case 2:return new t(e,r)}return new t(e,r,n)}return t.apply(this,arguments)};return e.prototype=t.prototype,e},U=function(t,e){var r,o,i,a,u,c,s,f,l=t.target,h=t.global,p=t.stat,v=t.proto,d=h?n:p?n[l]:(n[l]||{}).prototype,y=h?L:L[l]||(L[l]={}),g=y.prototype;for(i in e)r=!D(h?i:l+(p?".":"#")+i,t.forced)&&d&&b(d,i),u=y[i],r&&(c=t.noTargetGet?(f=G(d,i))&&f.value:d[i]),a=r&&c?c:e[i],r&&typeof u==typeof a||(s=t.bind&&r?R(a,n):t.wrap&&r?z(a):v&&"function"==typeof a?R(Function.call,a):a,(t.sham||a&&a.sham||u&&u.sham)&&q(s,"sham",!0),y[i]=s,v&&(b(L,o=l+"Prototype")||q(L,o,{}),L[o][i]=a,t.real&&g&&!g[i]&&q(g,i,a)))},V=Array.isArray||function(t){return"Array"==l(t)},J=Math.ceil,$=Math.floor,W=function(t){return isNaN(t=+t)?0:(t>0?$:J)(t)},B=Math.min,K=function(t){return t>0?B(W(t),9007199254740991):0},Y=function(t,e,r,n,o,i,a,u){for(var c,s=o,f=0,l=!!a&&R(a,u,3);f<n;){if(f in r){if(c=l?l(r[f],f,e):r[f],i>0&&V(c))s=Y(t,e,c,K(c.length),s,i-1)-1;else{if(s>=9007199254740991)throw TypeError("Exceed the acceptable array length");t[s]=c}s++}f++}return s},H=Y,Q=function(t){return Object(v(t))},X=n["__core-js_shared__"]||function(t,e){try{q(n,t,e)}catch(r){n[t]=e}return e}("__core-js_shared__",{}),Z=e((function(t){(t.exports=function(t,e){return X[t]||(X[t]=void 0!==e?e:{})})("versions",[]).push({version:"3.7.0",mode:"pure",copyright:"© 2020 Denis Pushkarev (zloirock.ru)"})})),tt=0,et=Math.random(),rt=function(t){return"Symbol("+String(void 0===t?"":t)+")_"+(++tt+et).toString(36)},nt=!!Object.getOwnPropertySymbols&&!o((function(){return!String(Symbol())})),ot=nt&&!Symbol.sham&&"symbol"==typeof Symbol.iterator,it=Z("wks"),at=n.Symbol,ut=ot?at:at&&at.withoutSetter||rt,ct=function(t){return b(it,t)||(nt&&b(at,t)?it[t]=at[t]:it[t]=ut("Symbol."+t)),it[t]},st=ct("species"),ft=function(t,e){var r;return V(t)&&("function"!=typeof(r=t.constructor)||r!==Array&&!V(r.prototype)?y(r)&&null===(r=r[st])&&(r=void 0):r=void 0),new(void 0===r?Array:r)(0===e?0:e)};U({target:"Array",proto:!0},{flatMap:function(t){var e,r=Q(this),n=K(r.length);return C(t),(e=ft(r,0)).length=H(e,r,r,n,0,1,t,arguments.length>1?arguments[1]:void 0),e}});var lt,ht,pt=function(t){return L[t+"Prototype"]},vt=pt("Array").flatMap,dt=Array.prototype,yt=function(t){var e=t.flatMap;return t===dt||t instanceof Array&&e===dt.flatMap?vt:e},gt=[].push,mt=function(t){var e=1==t,r=2==t,n=3==t,o=4==t,i=6==t,a=5==t||i;return function(u,c,s,f){for(var l,h,v=Q(u),d=p(v),y=R(c,s,3),g=K(d.length),m=0,b=f||ft,_=e?b(u,g):r?b(u,0):void 0;g>m;m++)if((a||m in d)&&(h=y(l=d[m],m,v),t))if(e)_[m]=h;else if(h)switch(t){case 3:return!0;case 5:return l;case 6:return m;case 2:gt.call(_,l)}else if(o)return!1;return i?-1:n||o?o:_}},bt={forEach:mt(0),map:mt(1),filter:mt(2),some:mt(3),every:mt(4),find:mt(5),findIndex:mt(6)},_t=function(t){return"function"==typeof t?t:void 0},wt=function(t,e){return arguments.length<2?_t(L[t])||_t(n[t]):L[t]&&L[t][e]||n[t]&&n[t][e]},Ot=wt("navigator","userAgent")||"",xt=n.process,St=xt&&xt.versions,kt=St&&St.v8;kt?ht=(lt=kt.split("."))[0]+lt[1]:Ot&&(!(lt=Ot.match(/Edge\/(\d+)/))||lt[1]>=74)&&(lt=Ot.match(/Chrome\/(\d+)/))&&(ht=lt[1]);var At=ht&&+ht,jt=ct("species"),Et=function(t){return At>=51||!o((function(){var e=[];return(e.constructor={})[jt]=function(){return{foo:1}},1!==e[t](Boolean).foo}))},It=Object.defineProperty,Pt={},Tt=function(t){throw t},Dt=function(t,e){if(b(Pt,t))return Pt[t];e||(e={});var r=[][t],n=!!b(e,"ACCESSORS")&&e.ACCESSORS,a=b(e,0)?e[0]:Tt,u=b(e,1)?e[1]:void 0;return Pt[t]=!!r&&!o((function(){if(n&&!i)return!0;var t={length:-1};n?It(t,1,{enumerable:!0,get:Tt}):t[1]=1,r.call(t,a,u)}))},Lt=bt.map,Ct=Et("map"),Rt=Dt("map");U({target:"Array",proto:!0,forced:!Ct||!Rt},{map:function(t){return Lt(this,t,arguments.length>1?arguments[1]:void 0)}});var Mt=pt("Array").map,Ft=Array.prototype,Nt=function(t){var e=t.map;return t===Ft||t instanceof Array&&e===Ft.map?Mt:e},qt=bt.filter,Gt=Et("filter"),zt=Dt("filter");U({target:"Array",proto:!0,forced:!Gt||!zt},{filter:function(t){return qt(this,t,arguments.length>1?arguments[1]:void 0)}});var Ut=pt("Array").filter,Vt=Array.prototype,Jt=function(t){var e=t.filter;return t===Vt||t instanceof Array&&e===Vt.filter?Ut:e},$t=function(t){return function(e,r,n,o){C(r);var i=Q(e),a=p(i),u=K(i.length),c=t?u-1:0,s=t?-1:1;if(n<2)for(;;){if(c in a){o=a[c],c+=s;break}if(c+=s,t?c<0:u<=c)throw TypeError("Reduce of empty array with no initial value")}for(;t?c>=0:u>c;c+=s)c in a&&(o=r(o,a[c],c,i));return o}},Wt={left:$t(!1),right:$t(!0)},Bt=function(t,e){var r=[][t];return!!r&&o((function(){r.call(null,e||function(){throw 1},1)}))},Kt="process"==l(n.process),Yt=Wt.left,Ht=Bt("reduce"),Qt=Dt("reduce",{1:0});U({target:"Array",proto:!0,forced:!Ht||!Qt||!Kt&&At>79&&At<83},{reduce:function(t){return Yt(this,t,arguments.length,arguments.length>1?arguments[1]:void 0)}});var Xt=pt("Array").reduce,Zt=Array.prototype,te=function(t){var e=t.reduce;return t===Zt||t instanceof Array&&e===Zt.reduce?Xt:e},ee=[].slice,re={},ne=function(t,e,r){if(!(e in re)){for(var n=[],o=0;o<e;o++)n[o]="a["+o+"]";re[e]=Function("C,a","return new C("+n.join(",")+")")}return re[e](t,r)},oe=Function.bind||function(t){var e=C(this),r=ee.call(arguments,1),n=function(){var o=r.concat(ee.call(arguments));return this instanceof n?ne(e,o.length,o):e.apply(t,o)};return y(e.prototype)&&(n.prototype=e.prototype),n};U({target:"Function",proto:!0},{bind:oe});var ie=pt("Function").bind,ae=Function.prototype,ue=function(t){var e=t.bind;return t===ae||t instanceof Function&&e===ae.bind?ie:e};var ce=function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")};U({target:"Object",stat:!0,forced:!i,sham:!i},{defineProperty:N.f});var se=e((function(t){var e=L.Object,r=t.exports=function(t,r,n){return e.defineProperty(t,r,n)};e.defineProperty.sham&&(r.sham=!0)})),fe=se;function le(t,e){for(var r=0;r<e.length;r++){var n=e[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),fe(t,n.key,n)}}var he=function(t,e,r){return e&&le(t.prototype,e),r&&le(t,r),t};function pe(t){return new de(t)}var ve=function(){function t(e,r,n){var o,i,a;ce(this,t),this._source=e,this._transformers=r,this._target=n,this._listeners={add:ue(o=this._add).call(o,this),remove:ue(i=this._remove).call(i,this),update:ue(a=this._update).call(a,this)}}return he(t,[{key:"all",value:function(){return this._target.update(this._transformItems(this._source.get())),this}},{key:"start",value:function(){return this._source.on("add",this._listeners.add),this._source.on("remove",this._listeners.remove),this._source.on("update",this._listeners.update),this}},{key:"stop",value:function(){return this._source.off("add",this._listeners.add),this._source.off("remove",this._listeners.remove),this._source.off("update",this._listeners.update),this}},{key:"_transformItems",value:function(t){var e;return te(e=this._transformers).call(e,(function(t,e){return e(t)}),t)}},{key:"_add",value:function(t,e){null!=e&&this._target.add(this._transformItems(this._source.get(e.items)))}},{key:"_update",value:function(t,e){null!=e&&this._target.update(this._transformItems(this._source.get(e.items)))}},{key:"_remove",value:function(t,e){null!=e&&this._target.remove(this._transformItems(e.oldData))}}]),t}(),de=function(){function t(e){ce(this,t),this._source=e,this._transformers=[]}return he(t,[{key:"filter",value:function(t){return this._transformers.push((function(e){return Jt(e).call(e,t)})),this}},{key:"map",value:function(t){return this._transformers.push((function(e){return Nt(e).call(e,t)})),this}},{key:"flatMap",value:function(t){return this._transformers.push((function(e){return yt(e).call(e,t)})),this}},{key:"to",value:function(t){return new ve(this._source,this._transformers,t)}}]),t}(),ye=se,ge=Math.max,me=Math.min,be=function(t,e){var r=W(t);return r<0?ge(r+e,0):me(r,e)},_e=function(t){return function(e,r,n){var o,i=d(e),a=K(i.length),u=be(n,a);if(t&&r!=r){for(;a>u;)if((o=i[u++])!=o)return!0}else for(;a>u;u++)if((t||u in i)&&i[u]===r)return t||u||0;return!t&&-1}},we={includes:_e(!0),indexOf:_e(!1)},Oe={},xe=we.indexOf,Se=function(t,e){var r,n=d(t),o=0,i=[];for(r in n)!b(Oe,r)&&b(n,r)&&i.push(r);for(;e.length>o;)b(n,r=e[o++])&&(~xe(i,r)||i.push(r));return i},ke=["constructor","hasOwnProperty","isPrototypeOf","propertyIsEnumerable","toLocaleString","toString","valueOf"],Ae=Object.keys||function(t){return Se(t,ke)},je=i?Object.defineProperties:function(t,e){M(t);for(var r,n=Ae(e),o=n.length,i=0;o>i;)N.f(t,r=n[i++],e[r]);return t};U({target:"Object",stat:!0,forced:!i,sham:!i},{defineProperties:je});var Ee=e((function(t){var e=L.Object,r=t.exports=function(t,r){return e.defineProperties(t,r)};e.defineProperties.sham&&(r.sham=!0)})),Ie=ke.concat("length","prototype"),Pe={f:Object.getOwnPropertyNames||function(t){return Se(t,Ie)}},Te={f:Object.getOwnPropertySymbols},De=wt("Reflect","ownKeys")||function(t){var e=Pe.f(M(t)),r=Te.f;return r?e.concat(r(t)):e},Le=function(t,e,r){var n=g(e);n in t?N.f(t,n,s(0,r)):t[n]=r};U({target:"Object",stat:!0,sham:!i},{getOwnPropertyDescriptors:function(t){for(var e,r,n=d(t),o=k.f,i=De(n),a={},u=0;i.length>u;)void 0!==(r=o(n,e=i[u++]))&&Le(a,e,r);return a}});var Ce=L.Object.getOwnPropertyDescriptors,Re=k.f,Me=o((function(){Re(1)}));U({target:"Object",stat:!0,forced:!i||Me,sham:!i},{getOwnPropertyDescriptor:function(t,e){return Re(d(t),e)}});var Fe,Ne=e((function(t){var e=L.Object,r=t.exports=function(t,r){return e.getOwnPropertyDescriptor(t,r)};e.getOwnPropertyDescriptor.sham&&(r.sham=!0)})),qe=wt("document","documentElement"),Ge=Z("keys"),ze=function(t){return Ge[t]||(Ge[t]=rt(t))},Ue=ze("IE_PROTO"),Ve=function(){},Je=function(t){return"<script>"+t+"<\/script>"},$e=function(){try{Fe=document.domain&&new ActiveXObject("htmlfile")}catch(t){}var t,e;$e=Fe?function(t){t.write(Je("")),t.close();var e=t.parentWindow.Object;return t=null,e}(Fe):((e=O("iframe")).style.display="none",qe.appendChild(e),e.src=String("javascript:"),(t=e.contentWindow.document).open(),t.write(Je("document.F=Object")),t.close(),t.F);for(var r=ke.length;r--;)delete $e.prototype[ke[r]];return $e()};Oe[Ue]=!0;var We=Object.create||function(t,e){var r;return null!==t?(Ve.prototype=M(t),r=new Ve,Ve.prototype=null,r[Ue]=t):r=$e(),void 0===e?r:je(r,e)},Be=Pe.f,Ke={}.toString,Ye="object"==typeof window&&window&&Object.getOwnPropertyNames?Object.getOwnPropertyNames(window):[],He={f:function(t){return Ye&&"[object Window]"==Ke.call(t)?function(t){try{return Be(t)}catch(t){return Ye.slice()}}(t):Be(d(t))}},Qe=function(t,e,r,n){n&&n.enumerable?t[e]=r:q(t,e,r)},Xe={f:ct},Ze=N.f,tr=function(t){var e=L.Symbol||(L.Symbol={});b(e,t)||Ze(e,t,{value:Xe.f(t)})},er={};er[ct("toStringTag")]="z";var rr="[object z]"===String(er),nr=ct("toStringTag"),or="Arguments"==l(function(){return arguments}()),ir=rr?l:function(t){var e,r,n;return void 0===t?"Undefined":null===t?"Null":"string"==typeof(r=function(t,e){try{return t[e]}catch(t){}}(e=Object(t),nr))?r:or?l(e):"Object"==(n=l(e))&&"function"==typeof e.callee?"Arguments":n},ar=rr?{}.toString:function(){return"[object "+ir(this)+"]"},ur=N.f,cr=ct("toStringTag"),sr=function(t,e,r,n){if(t){var o=r?t:t.prototype;b(o,cr)||ur(o,cr,{configurable:!0,value:e}),n&&!rr&&q(o,"toString",ar)}},fr=Function.toString;"function"!=typeof X.inspectSource&&(X.inspectSource=function(t){return fr.call(t)});var lr,hr,pr,vr=X.inspectSource,dr=n.WeakMap,yr="function"==typeof dr&&/native code/.test(vr(dr)),gr=n.WeakMap;if(yr){var mr=X.state||(X.state=new gr),br=mr.get,_r=mr.has,wr=mr.set;lr=function(t,e){return e.facade=t,wr.call(mr,t,e),e},hr=function(t){return br.call(mr,t)||{}},pr=function(t){return _r.call(mr,t)}}else{var Or=ze("state");Oe[Or]=!0,lr=function(t,e){return e.facade=t,q(t,Or,e),e},hr=function(t){return b(t,Or)?t[Or]:{}},pr=function(t){return b(t,Or)}}var xr={set:lr,get:hr,has:pr,enforce:function(t){return pr(t)?hr(t):lr(t,{})},getterFor:function(t){return function(e){var r;if(!y(e)||(r=hr(e)).type!==t)throw TypeError("Incompatible receiver, "+t+" required");return r}}},Sr=bt.forEach,kr=ze("hidden"),Ar=ct("toPrimitive"),jr=xr.set,Er=xr.getterFor("Symbol"),Ir=Object.prototype,Pr=n.Symbol,Tr=wt("JSON","stringify"),Dr=k.f,Lr=N.f,Cr=He.f,Rr=c.f,Mr=Z("symbols"),Fr=Z("op-symbols"),Nr=Z("string-to-symbol-registry"),qr=Z("symbol-to-string-registry"),Gr=Z("wks"),zr=n.QObject,Ur=!zr||!zr.prototype||!zr.prototype.findChild,Vr=i&&o((function(){return 7!=We(Lr({},"a",{get:function(){return Lr(this,"a",{value:7}).a}})).a}))?function(t,e,r){var n=Dr(Ir,e);n&&delete Ir[e],Lr(t,e,r),n&&t!==Ir&&Lr(Ir,e,n)}:Lr,Jr=function(t,e){var r=Mr[t]=We(Pr.prototype);return jr(r,{type:"Symbol",tag:t,description:e}),i||(r.description=e),r},$r=ot?function(t){return"symbol"==typeof t}:function(t){return Object(t)instanceof Pr},Wr=function(t,e,r){t===Ir&&Wr(Fr,e,r),M(t);var n=g(e,!0);return M(r),b(Mr,n)?(r.enumerable?(b(t,kr)&&t[kr][n]&&(t[kr][n]=!1),r=We(r,{enumerable:s(0,!1)})):(b(t,kr)||Lr(t,kr,s(1,{})),t[kr][n]=!0),Vr(t,n,r)):Lr(t,n,r)},Br=function(t,e){M(t);var r=d(e),n=Ae(r).concat(Qr(r));return Sr(n,(function(e){i&&!Kr.call(r,e)||Wr(t,e,r[e])})),t},Kr=function(t){var e=g(t,!0),r=Rr.call(this,e);return!(this===Ir&&b(Mr,e)&&!b(Fr,e))&&(!(r||!b(this,e)||!b(Mr,e)||b(this,kr)&&this[kr][e])||r)},Yr=function(t,e){var r=d(t),n=g(e,!0);if(r!==Ir||!b(Mr,n)||b(Fr,n)){var o=Dr(r,n);return!o||!b(Mr,n)||b(r,kr)&&r[kr][n]||(o.enumerable=!0),o}},Hr=function(t){var e=Cr(d(t)),r=[];return Sr(e,(function(t){b(Mr,t)||b(Oe,t)||r.push(t)})),r},Qr=function(t){var e=t===Ir,r=Cr(e?Fr:d(t)),n=[];return Sr(r,(function(t){!b(Mr,t)||e&&!b(Ir,t)||n.push(Mr[t])})),n};if(nt||(Qe((Pr=function(){if(this instanceof Pr)throw TypeError("Symbol is not a constructor");var t=arguments.length&&void 0!==arguments[0]?String(arguments[0]):void 0,e=rt(t),r=function(t){this===Ir&&r.call(Fr,t),b(this,kr)&&b(this[kr],e)&&(this[kr][e]=!1),Vr(this,e,s(1,t))};return i&&Ur&&Vr(Ir,e,{configurable:!0,set:r}),Jr(e,t)}).prototype,"toString",(function(){return Er(this).tag})),Qe(Pr,"withoutSetter",(function(t){return Jr(rt(t),t)})),c.f=Kr,N.f=Wr,k.f=Yr,Pe.f=He.f=Hr,Te.f=Qr,Xe.f=function(t){return Jr(ct(t),t)},i&&Lr(Pr.prototype,"description",{configurable:!0,get:function(){return Er(this).description}})),U({global:!0,wrap:!0,forced:!nt,sham:!nt},{Symbol:Pr}),Sr(Ae(Gr),(function(t){tr(t)})),U({target:"Symbol",stat:!0,forced:!nt},{for:function(t){var e=String(t);if(b(Nr,e))return Nr[e];var r=Pr(e);return Nr[e]=r,qr[r]=e,r},keyFor:function(t){if(!$r(t))throw TypeError(t+" is not a symbol");if(b(qr,t))return qr[t]},useSetter:function(){Ur=!0},useSimple:function(){Ur=!1}}),U({target:"Object",stat:!0,forced:!nt,sham:!i},{create:function(t,e){return void 0===e?We(t):Br(We(t),e)},defineProperty:Wr,defineProperties:Br,getOwnPropertyDescriptor:Yr}),U({target:"Object",stat:!0,forced:!nt},{getOwnPropertyNames:Hr,getOwnPropertySymbols:Qr}),U({target:"Object",stat:!0,forced:o((function(){Te.f(1)}))},{getOwnPropertySymbols:function(t){return Te.f(Q(t))}}),Tr){var Xr=!nt||o((function(){var t=Pr();return"[null]"!=Tr([t])||"{}"!=Tr({a:t})||"{}"!=Tr(Object(t))}));U({target:"JSON",stat:!0,forced:Xr},{stringify:function(t,e,r){for(var n,o=[t],i=1;arguments.length>i;)o.push(arguments[i++]);if(n=e,(y(e)||void 0!==t)&&!$r(t))return V(e)||(e=function(t,e){if("function"==typeof n&&(e=n.call(this,t,e)),!$r(e))return e}),o[1]=e,Tr.apply(null,o)}})}Pr.prototype[Ar]||q(Pr.prototype,Ar,Pr.prototype.valueOf),sr(Pr,"Symbol"),Oe[kr]=!0;var Zr,tn,en,rn=L.Object.getOwnPropertySymbols,nn={},on=!o((function(){function t(){}return t.prototype.constructor=null,Object.getPrototypeOf(new t)!==t.prototype})),an=ze("IE_PROTO"),un=Object.prototype,cn=on?Object.getPrototypeOf:function(t){return t=Q(t),b(t,an)?t[an]:"function"==typeof t.constructor&&t instanceof t.constructor?t.constructor.prototype:t instanceof Object?un:null},sn=(ct("iterator"),!1);[].keys&&("next"in(en=[].keys())?(tn=cn(cn(en)))!==Object.prototype&&(Zr=tn):sn=!0),null==Zr&&(Zr={});var fn={IteratorPrototype:Zr,BUGGY_SAFARI_ITERATORS:sn},ln=fn.IteratorPrototype,hn=function(){return this},pn=Object.setPrototypeOf||("__proto__"in{}?function(){var t,e=!1,r={};try{(t=Object.getOwnPropertyDescriptor(Object.prototype,"__proto__").set).call(r,[]),e=r instanceof Array}catch(t){}return function(r,n){return M(r),function(t){if(!y(t)&&null!==t)throw TypeError("Can't set "+String(t)+" as a prototype")}(n),e?t.call(r,n):r.__proto__=n,r}}():void 0),vn=fn.IteratorPrototype,dn=fn.BUGGY_SAFARI_ITERATORS,yn=ct("iterator"),gn=function(){return this},mn=function(t,e,r,n,o,i,a){!function(t,e,r){var n=e+" Iterator";t.prototype=We(ln,{next:s(1,r)}),sr(t,n,!1,!0),nn[n]=hn}(r,e,n);var u,c,f,l=function(t){if(t===o&&y)return y;if(!dn&&t in v)return v[t];switch(t){case"keys":case"values":case"entries":return function(){return new r(this,t)}}return function(){return new r(this)}},h=e+" Iterator",p=!1,v=t.prototype,d=v[yn]||v["@@iterator"]||o&&v[o],y=!dn&&d||l(o),g="Array"==e&&v.entries||d;if(g&&(u=cn(g.call(new t)),vn!==Object.prototype&&u.next&&(sr(u,h,!0,!0),nn[h]=gn)),"values"==o&&d&&"values"!==d.name&&(p=!0,y=function(){return d.call(this)}),a&&v[yn]!==y&&q(v,yn,y),nn[e]=y,o)if(c={values:l("values"),keys:i?y:l("keys"),entries:l("entries")},a)for(f in c)(dn||p||!(f in v))&&Qe(v,f,c[f]);else U({target:e,proto:!0,forced:dn||p},c);return c},bn=xr.set,_n=xr.getterFor("Array Iterator");mn(Array,"Array",(function(t,e){bn(this,{type:"Array Iterator",target:d(t),index:0,kind:e})}),(function(){var t=_n(this),e=t.target,r=t.kind,n=t.index++;return!e||n>=e.length?(t.target=void 0,{value:void 0,done:!0}):"keys"==r?{value:n,done:!1}:"values"==r?{value:e[n],done:!1}:{value:[n,e[n]],done:!1}}),"values");nn.Arguments=nn.Array;var wn=ct("toStringTag");for(var On in{CSSRuleList:0,CSSStyleDeclaration:0,CSSValueList:0,ClientRectList:0,DOMRectList:0,DOMStringList:0,DOMTokenList:1,DataTransferItemList:0,FileList:0,HTMLAllCollection:0,HTMLCollection:0,HTMLFormElement:0,HTMLSelectElement:0,MediaList:0,MimeTypeArray:0,NamedNodeMap:0,NodeList:1,PaintRequestList:0,Plugin:0,PluginArray:0,SVGLengthList:0,SVGNumberList:0,SVGPathSegList:0,SVGPointList:0,SVGStringList:0,SVGTransformList:0,SourceBufferList:0,StyleSheetList:0,TextTrackCueList:0,TextTrackList:0,TouchList:0}){var xn=n[On],Sn=xn&&xn.prototype;Sn&&ir(Sn)!==wn&&q(Sn,wn,On),nn[On]=nn.Array}var kn=function(t){return function(e,r){var n,o,i=String(v(e)),a=W(r),u=i.length;return a<0||a>=u?t?"":void 0:(n=i.charCodeAt(a))<55296||n>56319||a+1===u||(o=i.charCodeAt(a+1))<56320||o>57343?t?i.charAt(a):n:t?i.slice(a,a+2):o-56320+(n-55296<<10)+65536}},An={codeAt:kn(!1),charAt:kn(!0)}.charAt,jn=xr.set,En=xr.getterFor("String Iterator");mn(String,"String",(function(t){jn(this,{type:"String Iterator",string:String(t),index:0})}),(function(){var t,e=En(this),r=e.string,n=e.index;return n>=r.length?{value:void 0,done:!0}:(t=An(r,n),e.index+=t.length,{value:t,done:!1})}));var In=ct("iterator"),Pn=function(t){if(null!=t)return t[In]||t["@@iterator"]||nn[ir(t)]},Tn=function(t){var e=Pn(t);if("function"!=typeof e)throw TypeError(String(t)+" is not iterable");return M(e.call(t))},Dn=Pn,Ln=function(t){var e=t.return;if(void 0!==e)return M(e.call(t)).value},Cn=function(t,e,r,n){try{return n?e(M(r)[0],r[1]):e(r)}catch(e){throw Ln(t),e}},Rn=ct("iterator"),Mn=Array.prototype,Fn=function(t){return void 0!==t&&(nn.Array===t||Mn[Rn]===t)},Nn=ct("iterator"),qn=!1;try{var Gn=0,zn={next:function(){return{done:!!Gn++}},return:function(){qn=!0}};zn[Nn]=function(){return this},Array.from(zn,(function(){throw 2}))}catch(t){}var Un=!function(t,e){if(!e&&!qn)return!1;var r=!1;try{var n={};n[Nn]=function(){return{next:function(){return{done:r=!0}}}},t(n)}catch(t){}return r}((function(t){Array.from(t)}));U({target:"Array",stat:!0,forced:Un},{from:function(t){var e,r,n,o,i,a,u=Q(t),c="function"==typeof this?this:Array,s=arguments.length,f=s>1?arguments[1]:void 0,l=void 0!==f,h=Pn(u),p=0;if(l&&(f=R(f,s>2?arguments[2]:void 0,2)),null==h||c==Array&&Fn(h))for(r=new c(e=K(u.length));e>p;p++)a=l?f(u[p],p):u[p],Le(r,p,a);else for(i=(o=h.call(u)).next,r=new c;!(n=i.call(o)).done;p++)a=l?Cn(o,f,[n.value,p],!0):n.value,Le(r,p,a);return r.length=p,r}});var Vn=L.Array.from,Jn=Vn;U({target:"Object",stat:!0,sham:!i},{create:We});var $n=L.Object,Wn=function(t,e){return $n.create(t,e)},Bn=Wn;var Kn,Yn=function(t,e,r){return e in t?fe(t,e,{value:r,enumerable:!0,configurable:!0,writable:!0}):t[e]=r,t},Hn="\t\n\v\f\r                　\u2028\u2029\ufeff",Qn="["+Hn+"]",Xn=RegExp("^"+Qn+Qn+"*"),Zn=RegExp(Qn+Qn+"*$"),to=function(t){return function(e){var r=String(v(e));return 1&t&&(r=r.replace(Xn,"")),2&t&&(r=r.replace(Zn,"")),r}},eo={start:to(1),end:to(2),trim:to(3)},ro=eo.trim;U({target:"String",proto:!0,forced:(Kn="trim",o((function(){return!!Hn[Kn]()||"​᠎"!="​᠎"[Kn]()||Hn[Kn].name!==Kn})))},{trim:function(){return ro(this)}});pt("String").trim;var no=bt.forEach,oo=Bt("forEach"),io=Dt("forEach"),ao=oo&&io?[].forEach:function(t){return no(this,t,arguments.length>1?arguments[1]:void 0)};U({target:"Array",proto:!0,forced:[].forEach!=ao},{forEach:ao});var uo=pt("Array").forEach,co=Array.prototype,so={DOMTokenList:!0,NodeList:!0},fo=function(t){var e=t.forEach;return t===co||t instanceof Array&&e===co.forEach||so.hasOwnProperty(ir(t))?uo:e},lo=eo.trim,ho=n.parseInt,po=/^[+-]?0[Xx]/,vo=8!==ho(Hn+"08")||22!==ho(Hn+"0x16")?function(t,e){var r=lo(String(t));return ho(r,e>>>0||(po.test(r)?16:10))}:ho;U({global:!0,forced:parseInt!=vo},{parseInt:vo});var yo=c.f,go=function(t){return function(e){for(var r,n=d(e),o=Ae(n),a=o.length,u=0,c=[];a>u;)r=o[u++],i&&!yo.call(n,r)||c.push(t?[r,n[r]]:n[r]);return c}},mo={entries:go(!0),values:go(!1)}.values;U({target:"Object",stat:!0},{values:function(t){return mo(t)}});L.Object.values;var bo=o((function(){cn(1)}));U({target:"Object",stat:!0,forced:bo,sham:!on},{getPrototypeOf:function(t){return cn(Q(t))}});var _o=L.Object.getPrototypeOf,wo=we.indexOf,Oo=[].indexOf,xo=!!Oo&&1/[1].indexOf(1,-0)<0,So=Bt("indexOf"),ko=Dt("indexOf",{ACCESSORS:!0,1:0});U({target:"Array",proto:!0,forced:xo||!So||!ko},{indexOf:function(t){return xo?Oo.apply(this,arguments)||0:wo(this,t,arguments.length>1?arguments[1]:void 0)}});pt("Array").indexOf;var Ao=Object.assign,jo=Object.defineProperty,Eo=!Ao||o((function(){if(i&&1!==Ao({b:1},Ao(jo({},"a",{enumerable:!0,get:function(){jo(this,"b",{value:3,enumerable:!1})}}),{b:2})).b)return!0;var t={},e={},r=Symbol(),n="abcdefghijklmnopqrst";return t[r]=7,n.split("").forEach((function(t){e[t]=t})),7!=Ao({},t)[r]||Ae(Ao({},e)).join("")!=n}))?function(t,e){for(var r=Q(t),n=arguments.length,o=1,a=Te.f,u=c.f;n>o;)for(var s,f=p(arguments[o++]),l=a?Ae(f).concat(a(f)):Ae(f),h=l.length,v=0;h>v;)s=l[v++],i&&!u.call(f,s)||(r[s]=f[s]);return r}:Ao;U({target:"Object",stat:!0,forced:Object.assign!==Eo},{assign:Eo});var Io=L.Object.assign;U({target:"Array",stat:!0},{isArray:V});var Po=L.Array.isArray,To=Po;var Do=function(t){if(To(t))return t},Lo=ct("iterator"),Co=function(t){var e=Object(t);return void 0!==e[Lo]||"@@iterator"in e||nn.hasOwnProperty(ir(e))},Ro=ct("isConcatSpreadable"),Mo=At>=51||!o((function(){var t=[];return t[Ro]=!1,t.concat()[0]!==t})),Fo=Et("concat"),No=function(t){if(!y(t))return!1;var e=t[Ro];return void 0!==e?!!e:V(t)};U({target:"Array",proto:!0,forced:!Mo||!Fo},{concat:function(t){var e,r,n,o,i,a=Q(this),u=ft(a,0),c=0;for(e=-1,n=arguments.length;e<n;e++)if(No(i=-1===e?a:arguments[e])){if(c+(o=K(i.length))>9007199254740991)throw TypeError("Maximum allowed index exceeded");for(r=0;r<o;r++,c++)r in i&&Le(u,c,i[r])}else{if(c>=9007199254740991)throw TypeError("Maximum allowed index exceeded");Le(u,c++,i)}return u.length=c,u}}),tr("asyncIterator"),tr("hasInstance"),tr("isConcatSpreadable"),tr("iterator"),tr("match"),tr("matchAll"),tr("replace"),tr("search"),tr("species"),tr("split"),tr("toPrimitive"),tr("toStringTag"),tr("unscopables"),sr(n.JSON,"JSON",!0);var qo=L.Symbol;tr("asyncDispose"),tr("dispose"),tr("observable"),tr("patternMatch"),tr("replaceAll");var Go=qo;var zo=function(t,e){if(void 0!==Go&&Co(Object(t))){var r=[],n=!0,o=!1,i=void 0;try{for(var a,u=Tn(t);!(n=(a=u.next()).done)&&(r.push(a.value),!e||r.length!==e);n=!0);}catch(t){o=!0,i=t}finally{try{n||null==u.return||u.return()}finally{if(o)throw i}}return r}},Uo=Vn,Vo=Et("slice"),Jo=Dt("slice",{ACCESSORS:!0,0:0,1:2}),$o=ct("species"),Wo=[].slice,Bo=Math.max;U({target:"Array",proto:!0,forced:!Vo||!Jo},{slice:function(t,e){var r,n,o,i=d(this),a=K(i.length),u=be(t,a),c=be(void 0===e?a:e,a);if(V(i)&&("function"!=typeof(r=i.constructor)||r!==Array&&!V(r.prototype)?y(r)&&null===(r=r[$o])&&(r=void 0):r=void 0,r===Array||void 0===r))return Wo.call(i,u,c);for(n=new(void 0===r?Array:r)(Bo(c-u,0)),o=0;u<c;u++,o++)u in i&&Le(n,o,i[u]);return n.length=o,n}});var Ko=pt("Array").slice,Yo=Array.prototype,Ho=function(t){var e=t.slice;return t===Yo||t instanceof Array&&e===Yo.slice?Ko:e},Qo=Ho;var Xo=function(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n};var Zo=function(t,e){var r;if(t){if("string"==typeof t)return Xo(t,e);var n=Qo(r=Object.prototype.toString.call(t)).call(r,8,-1);return"Object"===n&&t.constructor&&(n=t.constructor.name),"Map"===n||"Set"===n?Uo(t):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?Xo(t,e):void 0}};var ti=function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")};var ei=function(t,e){return Do(t)||zo(t,e)||Zo(t,e)||ti()};U({target:"Date",stat:!0},{now:function(){return(new Date).getTime()}});L.Date.now;var ri=o((function(){Ae(1)}));U({target:"Object",stat:!0,forced:ri},{keys:function(t){return Ae(Q(t))}});var ni=L.Object.keys,oi=Po,ii=Xe.f("iterator"),ai=ii,ui=e((function(t){function e(r){return t.exports=e="function"==typeof Go&&"symbol"==typeof ai?function(t){return typeof t}:function(t){return t&&"function"==typeof Go&&t.constructor===Go&&t!==Go.prototype?"symbol":typeof t},e(r)}t.exports=e}));U({target:"Reflect",stat:!0},{ownKeys:De});var ci=L.Reflect.ownKeys,si=Ho;var fi=function(t){if(To(t))return Xo(t)};var li=function(t){if(void 0!==Go&&Co(Object(t)))return Uo(t)};var hi=function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")};var pi=function(t){return fi(t)||li(t)||Zo(t)||hi()},vi=pt("Array").concat,di=Array.prototype,yi=function(t){var e=t.concat;return t===di||t instanceof Array&&e===di.concat?vi:e},gi=qo;function mi(t,e){var r;if(void 0===gi||null==Dn(t)){if(oi(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return bi(t,e);var n=si(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return Jn(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return bi(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,o=function(){};return{s:o,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,u=!1;return{s:function(){r=Tn(t)},n:function(){var t=r.next();return a=t.done,t},e:function(t){u=!0,i=t},f:function(){try{a||null==r.return||r.return()}finally{if(u)throw i}}}}function bi(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}
/**
 * vis-util
 * https://github.com/visjs/vis-util
 *
 * utilitie collection for visjs
 *
 * @version 4.3.4
 * @date    2020-08-01T15:11:53.524Z
 *
 * @copyright (c) 2011-2017 Almende B.V, http://almende.com
 * @copyright (c) 2017-2019 visjs contributors, https://github.com/visjs
 *
 * @license
 * vis.js is dual licensed under both
 *
 *   1. The Apache 2.0 License
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *   and
 *
 *   2. The MIT License
 *      http://opensource.org/licenses/MIT
 *
 * vis.js may be distributed under either license.
 */var _i=gi("DELETE");function wi(){var t=Oi.apply(void 0,arguments);return Si(t),t}function Oi(){for(var t=arguments.length,e=new Array(t),r=0;r<t;r++)e[r]=arguments[r];if(e.length<2)return e[0];var n;if(e.length>2)return Oi.apply(void 0,yi(n=[wi(e[0],e[1])]).call(n,pi(si(e).call(e,2))));var o,i=e[0],a=e[1],u=mi(ci(a));try{for(u.s();!(o=u.n()).done;){var c=o.value;Object.prototype.propertyIsEnumerable.call(a,c)&&(a[c]===_i?delete i[c]:null===i[c]||null===a[c]||"object"!==ui(i[c])||"object"!==ui(a[c])||oi(i[c])||oi(a[c])?i[c]=xi(a[c]):i[c]=Oi(i[c],a[c]))}}catch(t){u.e(t)}finally{u.f()}return i}function xi(t){return oi(t)?Nt(t).call(t,(function(t){return xi(t)})):"object"===ui(t)&&null!==t?Oi({},t):t}function Si(t){for(var e=0,r=ni(t);e<r.length;e++){var n=r[e];t[n]===_i?delete t[n]:"object"===ui(t[n])&&null!==t[n]&&Si(t[n])}}var ki=wt("Reflect","construct"),Ai=o((function(){function t(){}return!(ki((function(){}),[],t)instanceof t)})),ji=!o((function(){ki((function(){}))})),Ei=Ai||ji;U({target:"Reflect",stat:!0,forced:Ei,sham:Ei},{construct:function(t,e){C(t),M(e);var r=arguments.length<3?t:C(arguments[2]);if(ji&&!Ai)return ki(t,e,r);if(t==r){switch(e.length){case 0:return new t;case 1:return new t(e[0]);case 2:return new t(e[0],e[1]);case 3:return new t(e[0],e[1],e[2]);case 4:return new t(e[0],e[1],e[2],e[3])}var n=[null];return n.push.apply(n,e),new(oe.apply(t,n))}var o=r.prototype,i=We(y(o)?o:Object.prototype),a=Function.apply.call(t,i,e);return y(a)?a:i}});var Ii=L.Reflect.construct,Pi=pt("Array").entries,Ti=Array.prototype,Di={DOMTokenList:!0,NodeList:!0},Li=function(t){var e=t.entries;return t===Ti||t instanceof Array&&e===Ti.entries||Di.hasOwnProperty(ir(t))?Pi:e},Ci=e((function(t){var e=function(t){var e,r=Object.prototype,n=r.hasOwnProperty,o="function"==typeof Symbol?Symbol:{},i=o.iterator||"@@iterator",a=o.asyncIterator||"@@asyncIterator",u=o.toStringTag||"@@toStringTag";function c(t,e,r){return Object.defineProperty(t,e,{value:r,enumerable:!0,configurable:!0,writable:!0}),t[e]}try{c({},"")}catch(t){c=function(t,e,r){return t[e]=r}}function s(t,e,r,n){var o=e&&e.prototype instanceof y?e:y,i=Object.create(o.prototype),a=new E(n||[]);return i._invoke=function(t,e,r){var n=l;return function(o,i){if(n===p)throw new Error("Generator is already running");if(n===v){if("throw"===o)throw i;return P()}for(r.method=o,r.arg=i;;){var a=r.delegate;if(a){var u=k(a,r);if(u){if(u===d)continue;return u}}if("next"===r.method)r.sent=r._sent=r.arg;else if("throw"===r.method){if(n===l)throw n=v,r.arg;r.dispatchException(r.arg)}else"return"===r.method&&r.abrupt("return",r.arg);n=p;var c=f(t,e,r);if("normal"===c.type){if(n=r.done?v:h,c.arg===d)continue;return{value:c.arg,done:r.done}}"throw"===c.type&&(n=v,r.method="throw",r.arg=c.arg)}}}(t,r,a),i}function f(t,e,r){try{return{type:"normal",arg:t.call(e,r)}}catch(t){return{type:"throw",arg:t}}}t.wrap=s;var l="suspendedStart",h="suspendedYield",p="executing",v="completed",d={};function y(){}function g(){}function m(){}var b={};b[i]=function(){return this};var _=Object.getPrototypeOf,w=_&&_(_(I([])));w&&w!==r&&n.call(w,i)&&(b=w);var O=m.prototype=y.prototype=Object.create(b);function x(t){["next","throw","return"].forEach((function(e){c(t,e,(function(t){return this._invoke(e,t)}))}))}function S(t,e){function r(o,i,a,u){var c=f(t[o],t,i);if("throw"!==c.type){var s=c.arg,l=s.value;return l&&"object"==typeof l&&n.call(l,"__await")?e.resolve(l.__await).then((function(t){r("next",t,a,u)}),(function(t){r("throw",t,a,u)})):e.resolve(l).then((function(t){s.value=t,a(s)}),(function(t){return r("throw",t,a,u)}))}u(c.arg)}var o;this._invoke=function(t,n){function i(){return new e((function(e,o){r(t,n,e,o)}))}return o=o?o.then(i,i):i()}}function k(t,r){var n=t.iterator[r.method];if(n===e){if(r.delegate=null,"throw"===r.method){if(t.iterator.return&&(r.method="return",r.arg=e,k(t,r),"throw"===r.method))return d;r.method="throw",r.arg=new TypeError("The iterator does not provide a 'throw' method")}return d}var o=f(n,t.iterator,r.arg);if("throw"===o.type)return r.method="throw",r.arg=o.arg,r.delegate=null,d;var i=o.arg;return i?i.done?(r[t.resultName]=i.value,r.next=t.nextLoc,"return"!==r.method&&(r.method="next",r.arg=e),r.delegate=null,d):i:(r.method="throw",r.arg=new TypeError("iterator result is not an object"),r.delegate=null,d)}function A(t){var e={tryLoc:t[0]};1 in t&&(e.catchLoc=t[1]),2 in t&&(e.finallyLoc=t[2],e.afterLoc=t[3]),this.tryEntries.push(e)}function j(t){var e=t.completion||{};e.type="normal",delete e.arg,t.completion=e}function E(t){this.tryEntries=[{tryLoc:"root"}],t.forEach(A,this),this.reset(!0)}function I(t){if(t){var r=t[i];if(r)return r.call(t);if("function"==typeof t.next)return t;if(!isNaN(t.length)){var o=-1,a=function r(){for(;++o<t.length;)if(n.call(t,o))return r.value=t[o],r.done=!1,r;return r.value=e,r.done=!0,r};return a.next=a}}return{next:P}}function P(){return{value:e,done:!0}}return g.prototype=O.constructor=m,m.constructor=g,g.displayName=c(m,u,"GeneratorFunction"),t.isGeneratorFunction=function(t){var e="function"==typeof t&&t.constructor;return!!e&&(e===g||"GeneratorFunction"===(e.displayName||e.name))},t.mark=function(t){return Object.setPrototypeOf?Object.setPrototypeOf(t,m):(t.__proto__=m,c(t,u,"GeneratorFunction")),t.prototype=Object.create(O),t},t.awrap=function(t){return{__await:t}},x(S.prototype),S.prototype[a]=function(){return this},t.AsyncIterator=S,t.async=function(e,r,n,o,i){void 0===i&&(i=Promise);var a=new S(s(e,r,n,o),i);return t.isGeneratorFunction(r)?a:a.next().then((function(t){return t.done?t.value:a.next()}))},x(O),c(O,u,"Generator"),O[i]=function(){return this},O.toString=function(){return"[object Generator]"},t.keys=function(t){var e=[];for(var r in t)e.push(r);return e.reverse(),function r(){for(;e.length;){var n=e.pop();if(n in t)return r.value=n,r.done=!1,r}return r.done=!0,r}},t.values=I,E.prototype={constructor:E,reset:function(t){if(this.prev=0,this.next=0,this.sent=this._sent=e,this.done=!1,this.delegate=null,this.method="next",this.arg=e,this.tryEntries.forEach(j),!t)for(var r in this)"t"===r.charAt(0)&&n.call(this,r)&&!isNaN(+r.slice(1))&&(this[r]=e)},stop:function(){this.done=!0;var t=this.tryEntries[0].completion;if("throw"===t.type)throw t.arg;return this.rval},dispatchException:function(t){if(this.done)throw t;var r=this;function o(n,o){return u.type="throw",u.arg=t,r.next=n,o&&(r.method="next",r.arg=e),!!o}for(var i=this.tryEntries.length-1;i>=0;--i){var a=this.tryEntries[i],u=a.completion;if("root"===a.tryLoc)return o("end");if(a.tryLoc<=this.prev){var c=n.call(a,"catchLoc"),s=n.call(a,"finallyLoc");if(c&&s){if(this.prev<a.catchLoc)return o(a.catchLoc,!0);if(this.prev<a.finallyLoc)return o(a.finallyLoc)}else if(c){if(this.prev<a.catchLoc)return o(a.catchLoc,!0)}else{if(!s)throw new Error("try statement without catch or finally");if(this.prev<a.finallyLoc)return o(a.finallyLoc)}}}},abrupt:function(t,e){for(var r=this.tryEntries.length-1;r>=0;--r){var o=this.tryEntries[r];if(o.tryLoc<=this.prev&&n.call(o,"finallyLoc")&&this.prev<o.finallyLoc){var i=o;break}}i&&("break"===t||"continue"===t)&&i.tryLoc<=e&&e<=i.finallyLoc&&(i=null);var a=i?i.completion:{};return a.type=t,a.arg=e,i?(this.method="next",this.next=i.finallyLoc,d):this.complete(a)},complete:function(t,e){if("throw"===t.type)throw t.arg;return"break"===t.type||"continue"===t.type?this.next=t.arg:"return"===t.type?(this.rval=this.arg=t.arg,this.method="return",this.next="end"):"normal"===t.type&&e&&(this.next=e),d},finish:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var r=this.tryEntries[e];if(r.finallyLoc===t)return this.complete(r.completion,r.afterLoc),j(r),d}},catch:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var r=this.tryEntries[e];if(r.tryLoc===t){var n=r.completion;if("throw"===n.type){var o=n.arg;j(r)}return o}}throw new Error("illegal catch attempt")},delegateYield:function(t,r,n){return this.delegate={iterator:I(t),resultName:r,nextLoc:n},"next"===this.method&&(this.arg=e),d}},t}(t.exports);try{regeneratorRuntime=e}catch(t){Function("r","regeneratorRuntime = r")(e)}})),Ri=ii,Mi=wt("JSON","stringify"),Fi=/[\uD800-\uDFFF]/g,Ni=/^[\uD800-\uDBFF]$/,qi=/^[\uDC00-\uDFFF]$/,Gi=function(t,e,r){var n=r.charAt(e-1),o=r.charAt(e+1);return Ni.test(t)&&!qi.test(o)||qi.test(t)&&!Ni.test(n)?"\\u"+t.charCodeAt(0).toString(16):t},zi=o((function(){return'"\\udf06\\ud834"'!==Mi("\udf06\ud834")||'"\\udead"'!==Mi("\udead")}));Mi&&U({target:"JSON",stat:!0,forced:zi},{stringify:function(t,e,r){var n=Mi.apply(null,arguments);return"string"==typeof n?n.replace(Fi,Gi):n}}),L.JSON||(L.JSON={stringify:JSON.stringify});var Ui=function(t,e,r){return L.JSON.stringify.apply(null,arguments)},Vi=pt("Array").values,Ji=Array.prototype,$i={DOMTokenList:!0,NodeList:!0},Wi=function(t){var e=t.values;return t===Ji||t instanceof Array&&e===Ji.values||$i.hasOwnProperty(ir(t))?Vi:e},Bi=[],Ki=Bi.sort,Yi=o((function(){Bi.sort(void 0)})),Hi=o((function(){Bi.sort(null)})),Qi=Bt("sort");U({target:"Array",proto:!0,forced:Yi||!Hi||!Qi},{sort:function(t){return void 0===t?Ki.call(Q(this)):Ki.call(Q(this),C(t))}});var Xi=pt("Array").sort,Zi=Array.prototype,ta=function(t){var e=t.sort;return t===Zi||t instanceof Array&&e===Zi.sort?Xi:e},ea=pt("Array").keys,ra=Array.prototype,na={DOMTokenList:!0,NodeList:!0},oa=function(t){var e=t.keys;return t===ra||t instanceof Array&&e===ra.keys||na.hasOwnProperty(ir(t))?ea:e},ia=bt.some,aa=Bt("some"),ua=Dt("some");U({target:"Array",proto:!0,forced:!aa||!ua},{some:function(t){return ia(this,t,arguments.length>1?arguments[1]:void 0)}});var ca=pt("Array").some,sa=Array.prototype,fa=function(t){var e=t.some;return t===sa||t instanceof Array&&e===sa.some?ca:e},la=!o((function(){return Object.isExtensible(Object.preventExtensions({}))})),ha=e((function(t){var e=N.f,r=rt("meta"),n=0,o=Object.isExtensible||function(){return!0},i=function(t){e(t,r,{value:{objectID:"O"+ ++n,weakData:{}}})},a=t.exports={REQUIRED:!1,fastKey:function(t,e){if(!y(t))return"symbol"==typeof t?t:("string"==typeof t?"S":"P")+t;if(!b(t,r)){if(!o(t))return"F";if(!e)return"E";i(t)}return t[r].objectID},getWeakData:function(t,e){if(!b(t,r)){if(!o(t))return!0;if(!e)return!1;i(t)}return t[r].weakData},onFreeze:function(t){return la&&a.REQUIRED&&o(t)&&!b(t,r)&&i(t),t}};Oe[r]=!0})),pa=function(t,e){this.stopped=t,this.result=e},va=function(t,e,r){var n,o,i,a,u,c,s,f=r&&r.that,l=!(!r||!r.AS_ENTRIES),h=!(!r||!r.IS_ITERATOR),p=!(!r||!r.INTERRUPTED),v=R(e,f,1+l+p),d=function(t){return n&&Ln(n),new pa(!0,t)},y=function(t){return l?(M(t),p?v(t[0],t[1],d):v(t[0],t[1])):p?v(t,d):v(t)};if(h)n=t;else{if("function"!=typeof(o=Pn(t)))throw TypeError("Target is not iterable");if(Fn(o)){for(i=0,a=K(t.length);a>i;i++)if((u=y(t[i]))&&u instanceof pa)return u;return new pa(!1)}n=o.call(t)}for(c=n.next;!(s=c.call(n)).done;){try{u=y(s.value)}catch(t){throw Ln(n),t}if("object"==typeof u&&u&&u instanceof pa)return u}return new pa(!1)},da=function(t,e,r){if(!(t instanceof e))throw TypeError("Incorrect "+(r?r+" ":"")+"invocation");return t},ya=N.f,ga=bt.forEach,ma=xr.set,ba=xr.getterFor,_a=function(t,e,r){var a,u=-1!==t.indexOf("Map"),c=-1!==t.indexOf("Weak"),s=u?"set":"add",f=n[t],l=f&&f.prototype,h={};if(i&&"function"==typeof f&&(c||l.forEach&&!o((function(){(new f).entries().next()})))){a=e((function(e,r){ma(da(e,a,t),{type:t,collection:new f}),null!=r&&va(r,e[s],{that:e,AS_ENTRIES:u})}));var p=ba(t);ga(["add","clear","delete","forEach","get","has","set","keys","values","entries"],(function(t){var e="add"==t||"set"==t;!(t in l)||c&&"clear"==t||q(a.prototype,t,(function(r,n){var o=p(this).collection;if(!e&&c&&!y(r))return"get"==t&&void 0;var i=o[t](0===r?0:r,n);return e?this:i}))})),c||ya(a.prototype,"size",{configurable:!0,get:function(){return p(this).collection.size}})}else a=r.getConstructor(e,t,u,s),ha.REQUIRED=!0;return sr(a,t,!1,!0),h[t]=a,U({global:!0,forced:!0},h),c||r.setStrong(a,t,u),a},wa=function(t,e,r){for(var n in e)r&&r.unsafe&&t[n]?t[n]=e[n]:Qe(t,n,e[n],r);return t},Oa=ct("species"),xa=N.f,Sa=ha.fastKey,ka=xr.set,Aa=xr.getterFor,ja={getConstructor:function(t,e,r,n){var o=t((function(t,a){da(t,o,e),ka(t,{type:e,index:We(null),first:void 0,last:void 0,size:0}),i||(t.size=0),null!=a&&va(a,t[n],{that:t,AS_ENTRIES:r})})),a=Aa(e),u=function(t,e,r){var n,o,u=a(t),s=c(t,e);return s?s.value=r:(u.last=s={index:o=Sa(e,!0),key:e,value:r,previous:n=u.last,next:void 0,removed:!1},u.first||(u.first=s),n&&(n.next=s),i?u.size++:t.size++,"F"!==o&&(u.index[o]=s)),t},c=function(t,e){var r,n=a(t),o=Sa(e);if("F"!==o)return n.index[o];for(r=n.first;r;r=r.next)if(r.key==e)return r};return wa(o.prototype,{clear:function(){for(var t=a(this),e=t.index,r=t.first;r;)r.removed=!0,r.previous&&(r.previous=r.previous.next=void 0),delete e[r.index],r=r.next;t.first=t.last=void 0,i?t.size=0:this.size=0},delete:function(t){var e=this,r=a(e),n=c(e,t);if(n){var o=n.next,u=n.previous;delete r.index[n.index],n.removed=!0,u&&(u.next=o),o&&(o.previous=u),r.first==n&&(r.first=o),r.last==n&&(r.last=u),i?r.size--:e.size--}return!!n},forEach:function(t){for(var e,r=a(this),n=R(t,arguments.length>1?arguments[1]:void 0,3);e=e?e.next:r.first;)for(n(e.value,e.key,this);e&&e.removed;)e=e.previous},has:function(t){return!!c(this,t)}}),wa(o.prototype,r?{get:function(t){var e=c(this,t);return e&&e.value},set:function(t,e){return u(this,0===t?0:t,e)}}:{add:function(t){return u(this,t=0===t?0:t,t)}}),i&&xa(o.prototype,"size",{get:function(){return a(this).size}}),o},setStrong:function(t,e,r){var n=e+" Iterator",o=Aa(e),a=Aa(n);mn(t,e,(function(t,e){ka(this,{type:n,target:t,state:o(t),kind:e,last:void 0})}),(function(){for(var t=a(this),e=t.kind,r=t.last;r&&r.removed;)r=r.previous;return t.target&&(t.last=r=r?r.next:t.state.first)?"keys"==e?{value:r.key,done:!1}:"values"==e?{value:r.value,done:!1}:{value:[r.key,r.value],done:!1}:(t.target=void 0,{value:void 0,done:!0})}),r?"entries":"values",!r,!0),function(t){var e=wt(t),r=N.f;i&&e&&!e[Oa]&&r(e,Oa,{configurable:!0,get:function(){return this}})}(e)}},Ea=(_a("Map",(function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}}),ja),L.Map),Ia=Wn;U({target:"Object",stat:!0},{setPrototypeOf:pn});var Pa=L.Object.setPrototypeOf,Ta=e((function(t){function e(r,n){return t.exports=e=Pa||function(t,e){return t.__proto__=e,t},e(r,n)}t.exports=e}));var Da=function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=Ia(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&Ta(t,e)};var La=function(t){if(void 0===t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return t};var Ca=function(t,e){return!e||"object"!==ui(e)&&"function"!=typeof e?La(t):e},Ra=_o,Ma=e((function(t){function e(r){return t.exports=e=Pa?Ra:function(t){return t.__proto__||Ra(t)},e(r)}t.exports=e})),Fa="undefined"!=typeof crypto&&crypto.getRandomValues&&crypto.getRandomValues.bind(crypto)||"undefined"!=typeof msCrypto&&"function"==typeof msCrypto.getRandomValues&&msCrypto.getRandomValues.bind(msCrypto),Na=new Uint8Array(16);function qa(){if(!Fa)throw new Error("crypto.getRandomValues() not supported. See https://github.com/uuidjs/uuid#getrandomvalues-not-supported");return Fa(Na)}var Ga=/^(?:[0-9a-f]{8}-[0-9a-f]{4}-[1-5][0-9a-f]{3}-[89ab][0-9a-f]{3}-[0-9a-f]{12}|00000000-0000-0000-0000-000000000000)$/i;function za(t){return"string"==typeof t&&Ga.test(t)}for(var Ua=[],Va=0;Va<256;++Va)Ua.push((Va+256).toString(16).substr(1));function Ja(t,e,r){var n=(t=t||{}).random||(t.rng||qa)();if(n[6]=15&n[6]|64,n[8]=63&n[8]|128,e){r=r||0;for(var o=0;o<16;++o)e[r+o]=n[o];return e}return function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:0,r=(Ua[t[e+0]]+Ua[t[e+1]]+Ua[t[e+2]]+Ua[t[e+3]]+"-"+Ua[t[e+4]]+Ua[t[e+5]]+"-"+Ua[t[e+6]]+Ua[t[e+7]]+"-"+Ua[t[e+8]]+Ua[t[e+9]]+"-"+Ua[t[e+10]]+Ua[t[e+11]]+Ua[t[e+12]]+Ua[t[e+13]]+Ua[t[e+14]]+Ua[t[e+15]]).toLowerCase();if(!za(r))throw TypeError("Stringified UUID is invalid");return r}(n)}function $a(t){return"string"==typeof t||"number"==typeof t}var Wa=Et("splice"),Ba=Dt("splice",{ACCESSORS:!0,0:0,1:2}),Ka=Math.max,Ya=Math.min;U({target:"Array",proto:!0,forced:!Wa||!Ba},{splice:function(t,e){var r,n,o,i,a,u,c=Q(this),s=K(c.length),f=be(t,s),l=arguments.length;if(0===l?r=n=0:1===l?(r=0,n=s-f):(r=l-2,n=Ya(Ka(W(e),0),s-f)),s+r-n>9007199254740991)throw TypeError("Maximum allowed length exceeded");for(o=ft(c,n),i=0;i<n;i++)(a=f+i)in c&&Le(o,i,c[a]);if(o.length=n,r<n){for(i=f;i<s-n;i++)u=i+r,(a=i+n)in c?c[u]=c[a]:delete c[u];for(i=s;i>s-n+r;i--)delete c[i-1]}else if(r>n)for(i=s-n;i>f;i--)u=i+r-1,(a=i+n-1)in c?c[u]=c[a]:delete c[u];for(i=0;i<r;i++)c[i+f]=arguments[i+2];return c.length=s-n+r,o}});var Ha=pt("Array").splice,Qa=Array.prototype,Xa=function(t){var e=t.splice;return t===Qa||t instanceof Array&&e===Qa.splice?Ha:e},Za=[].slice,tu=/MSIE .\./.test(Ot),eu=function(t){return function(e,r){var n=arguments.length>2,o=n?Za.call(arguments,2):void 0;return t(n?function(){("function"==typeof e?e:Function(e)).apply(this,o)}:e,r)}};U({global:!0,bind:!0,forced:tu},{setTimeout:eu(n.setTimeout),setInterval:eu(n.setInterval)});var ru=L.setTimeout,nu=function(){function t(e){ce(this,t),this._queue=[],this._timeout=null,this._extended=null,this.delay=null,this.max=1/0,this.setOptions(e)}return he(t,[{key:"setOptions",value:function(t){t&&void 0!==t.delay&&(this.delay=t.delay),t&&void 0!==t.max&&(this.max=t.max),this._flushIfNeeded()}},{key:"destroy",value:function(){if(this.flush(),this._extended){for(var t=this._extended.object,e=this._extended.methods,r=0;r<e.length;r++){var n=e[r];n.original?t[n.name]=n.original:delete t[n.name]}this._extended=null}}},{key:"replace",value:function(t,e){var r=this,n=t[e];if(!n)throw new Error("Method "+e+" undefined");t[e]=function(){for(var t=arguments.length,e=new Array(t),o=0;o<t;o++)e[o]=arguments[o];r.queue({args:e,fn:n,context:this})}}},{key:"queue",value:function(t){"function"==typeof t?this._queue.push({fn:t}):this._queue.push(t),this._flushIfNeeded()}},{key:"_flushIfNeeded",value:function(){var t=this;this._queue.length>this.max&&this.flush(),null!=this._timeout&&(clearTimeout(this._timeout),this._timeout=null),this.queue.length>0&&"number"==typeof this.delay&&(this._timeout=ru((function(){t.flush()}),this.delay))}},{key:"flush",value:function(){var t,e;fo(t=Xa(e=this._queue).call(e,0)).call(t,(function(t){t.fn.apply(t.context||t.fn,t.args||[])}))}}],[{key:"extend",value:function(e,r){var n=new t(r);if(void 0!==e.flush)throw new Error("Target object already has a property flush");e.flush=function(){n.flush()};var o=[{name:"flush",original:void 0}];if(r&&r.replace)for(var i=0;i<r.replace.length;i++){var a=r.replace[i];o.push({name:a,original:e[a]}),n.replace(e,a)}return n._extended={object:e,methods:o},n}}]),t}(),ou=function(){function t(){ce(this,t),this._subscribers={"*":[],add:[],remove:[],update:[]},this.subscribe=t.prototype.on,this.unsubscribe=t.prototype.off}return he(t,[{key:"_trigger",value:function(t,e,r){var n,o;if("*"===t)throw new Error("Cannot trigger event *");fo(n=yi(o=[]).call(o,pi(this._subscribers[t]),pi(this._subscribers["*"]))).call(n,(function(n){n(t,e,null!=r?r:null)}))}},{key:"on",value:function(t,e){"function"==typeof e&&this._subscribers[t].push(e)}},{key:"off",value:function(t,e){var r;this._subscribers[t]=Jt(r=this._subscribers[t]).call(r,(function(t){return t!==e}))}}]),t}(),iu=(_a("Set",(function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}}),ja),L.Set);function au(t,e){var r;if(void 0===gi||null==Dn(t)){if(oi(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return uu(t,e);var n=si(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return Jn(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return uu(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,o=function(){};return{s:o,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,u=!1;return{s:function(){r=Tn(t)},n:function(){var t=r.next();return a=t.done,t},e:function(t){u=!0,i=t},f:function(){try{a||null==r.return||r.return()}finally{if(u)throw i}}}}function uu(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}var cu=function(){function t(e){ce(this,t),this._pairs=e}return he(t,[{key:Ri,value:Ci.mark((function t(){var e,r,n,o,i;return Ci.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=au(this._pairs),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=ei(r.value,2),o=n[0],i=n[1],t.next=7,[o,i];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"entries",value:Ci.mark((function t(){var e,r,n,o,i;return Ci.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=au(this._pairs),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=ei(r.value,2),o=n[0],i=n[1],t.next=7,[o,i];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"keys",value:Ci.mark((function t(){var e,r,n,o;return Ci.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=au(this._pairs),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=ei(r.value,1),o=n[0],t.next=7,o;case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"values",value:Ci.mark((function t(){var e,r,n,o;return Ci.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=au(this._pairs),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=ei(r.value,2),o=n[1],t.next=7,o;case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"toIdArray",value:function(){var t;return Nt(t=pi(this._pairs)).call(t,(function(t){return t[0]}))}},{key:"toItemArray",value:function(){var t;return Nt(t=pi(this._pairs)).call(t,(function(t){return t[1]}))}},{key:"toEntryArray",value:function(){return pi(this._pairs)}},{key:"toObjectMap",value:function(){var t,e=Bn(null),r=au(this._pairs);try{for(r.s();!(t=r.n()).done;){var n=ei(t.value,2),o=n[0],i=n[1];e[o]=i}}catch(t){r.e(t)}finally{r.f()}return e}},{key:"toMap",value:function(){return new Ea(this._pairs)}},{key:"toIdSet",value:function(){return new iu(this.toIdArray())}},{key:"toItemSet",value:function(){return new iu(this.toItemArray())}},{key:"cache",value:function(){return new t(pi(this._pairs))}},{key:"distinct",value:function(t){var e,r=new iu,n=au(this._pairs);try{for(n.s();!(e=n.n()).done;){var o=ei(e.value,2),i=o[0],a=o[1];r.add(t(a,i))}}catch(t){n.e(t)}finally{n.f()}return r}},{key:"filter",value:function(e){var r=this._pairs;return new t(Yn({},Ri,Ci.mark((function t(){var n,o,i,a,u;return Ci.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:n=au(r),t.prev=1,n.s();case 3:if((o=n.n()).done){t.next=10;break}if(i=ei(o.value,2),a=i[0],u=i[1],!e(u,a)){t.next=8;break}return t.next=8,[a,u];case 8:t.next=3;break;case 10:t.next=15;break;case 12:t.prev=12,t.t0=t.catch(1),n.e(t.t0);case 15:return t.prev=15,n.f(),t.finish(15);case 18:case"end":return t.stop()}}),t,null,[[1,12,15,18]])}))))}},{key:"forEach",value:function(t){var e,r=au(this._pairs);try{for(r.s();!(e=r.n()).done;){var n=ei(e.value,2),o=n[0];t(n[1],o)}}catch(t){r.e(t)}finally{r.f()}}},{key:"map",value:function(e){var r=this._pairs;return new t(Yn({},Ri,Ci.mark((function t(){var n,o,i,a,u;return Ci.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:n=au(r),t.prev=1,n.s();case 3:if((o=n.n()).done){t.next=9;break}return i=ei(o.value,2),a=i[0],u=i[1],t.next=7,[a,e(u,a)];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),n.e(t.t0);case 14:return t.prev=14,n.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,null,[[1,11,14,17]])}))))}},{key:"max",value:function(t){var e=Tn(this._pairs),r=e.next();if(r.done)return null;for(var n=r.value[1],o=t(r.value[1],r.value[0]);!(r=e.next()).done;){var i=ei(r.value,2),a=i[0],u=i[1],c=t(u,a);c>o&&(o=c,n=u)}return n}},{key:"min",value:function(t){var e=Tn(this._pairs),r=e.next();if(r.done)return null;for(var n=r.value[1],o=t(r.value[1],r.value[0]);!(r=e.next()).done;){var i=ei(r.value,2),a=i[0],u=i[1],c=t(u,a);c<o&&(o=c,n=u)}return n}},{key:"reduce",value:function(t,e){var r,n=au(this._pairs);try{for(n.s();!(r=n.n()).done;){var o=ei(r.value,2),i=o[0];e=t(e,o[1],i)}}catch(t){n.e(t)}finally{n.f()}return e}},{key:"sort",value:function(e){var r=this;return new t(Yn({},Ri,(function(){var t;return Tn(ta(t=pi(r._pairs)).call(t,(function(t,r){var n=ei(t,2),o=n[0],i=n[1],a=ei(r,2),u=a[0],c=a[1];return e(i,c,o,u)})))})))}}]),t}();function su(t,e){var r=ni(t);if(rn){var n=rn(t);e&&(n=Jt(n).call(n,(function(e){return Ne(t,e).enumerable}))),r.push.apply(r,n)}return r}function fu(t){for(var e=1;e<arguments.length;e++){var r,n=null!=arguments[e]?arguments[e]:{};if(e%2)fo(r=su(Object(n),!0)).call(r,(function(e){Yn(t,e,n[e])}));else if(Ce)Ee(t,Ce(n));else{var o;fo(o=su(Object(n))).call(o,(function(e){ye(t,e,Ne(n,e))}))}}return t}function lu(t,e){var r;if(void 0===gi||null==Dn(t)){if(oi(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return hu(t,e);var n=si(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return Jn(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return hu(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,o=function(){};return{s:o,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,u=!1;return{s:function(){r=Tn(t)},n:function(){var t=r.next();return a=t.done,t},e:function(t){u=!0,i=t},f:function(){try{a||null==r.return||r.return()}finally{if(u)throw i}}}}function hu(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}function pu(t){var e=function(){if("undefined"==typeof Reflect||!Ii)return!1;if(Ii.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Ii(Date,[],(function(){}))),!0}catch(t){return!1}}();return function(){var r,n=Ma(t);if(e){var o=Ma(this).constructor;r=Ii(n,arguments,o)}else r=n.apply(this,arguments);return Ca(this,r)}}var vu=function(t){Da(r,ou);var e=pu(r);function r(t,n){var o;return ce(this,r),(o=e.call(this))._queue=null,t&&!oi(t)&&(n=t,t=[]),o._options=n||{},o._data=new Ea,o.length=0,o._idProp=o._options.fieldId||"id",t&&t.length&&o.add(t),o.setOptions(n),o}return he(r,[{key:"setOptions",value:function(t){t&&void 0!==t.queue&&(!1===t.queue?this._queue&&(this._queue.destroy(),this._queue=null):(this._queue||(this._queue=nu.extend(this,{replace:["add","update","remove"]})),t.queue&&"object"===ui(t.queue)&&this._queue.setOptions(t.queue)))}},{key:"add",value:function(t,e){var r,n=this,o=[];if(oi(t)){var i=Nt(t).call(t,(function(t){return t[n._idProp]}));if(fa(i).call(i,(function(t){return n._data.has(t)})))throw new Error("A duplicate id was found in the parameter array.");for(var a=0,u=t.length;a<u;a++)r=this._addItem(t[a]),o.push(r)}else{if(!t||"object"!==ui(t))throw new Error("Unknown dataType");r=this._addItem(t),o.push(r)}return o.length&&this._trigger("add",{items:o},e),o}},{key:"update",value:function(t,e){var r=this,n=[],o=[],i=[],a=[],u=this._idProp,c=function(t){var e=t[u];if(null!=e&&r._data.has(e)){var c=t,s=Io({},r._data.get(e)),f=r._updateItem(c);o.push(f),a.push(c),i.push(s)}else{var l=r._addItem(t);n.push(l)}};if(oi(t))for(var s=0,f=t.length;s<f;s++)t[s]&&"object"===ui(t[s])?c(t[s]):console.warn("Ignoring input item, which is not an object at index "+s);else{if(!t||"object"!==ui(t))throw new Error("Unknown dataType");c(t)}if(n.length&&this._trigger("add",{items:n},e),o.length){var l={items:o,oldData:i,data:a};this._trigger("update",l,e)}return yi(n).call(n,o)}},{key:"updateOnly",value:function(t,e){var r,n=this;oi(t)||(t=[t]);var o=Nt(r=Nt(t).call(t,(function(t){var e=n._data.get(t[n._idProp]);if(null==e)throw new Error("Updating non-existent items is not allowed.");return{oldData:e,update:t}}))).call(r,(function(t){var e=t.oldData,r=t.update,o=e[n._idProp],i=function(t){for(var e,r=arguments.length,n=new Array(r>1?r-1:0),o=1;o<r;o++)n[o-1]=arguments[o];return wi.apply(void 0,yi(e=[{},t]).call(e,n))}(e,r);return n._data.set(o,i),{id:o,oldData:e,updatedData:i}}));if(o.length){var i={items:Nt(o).call(o,(function(t){return t.id})),oldData:Nt(o).call(o,(function(t){return t.oldData})),data:Nt(o).call(o,(function(t){return t.updatedData}))};return this._trigger("update",i,e),i.items}return[]}},{key:"get",value:function(t,e){var r=void 0,n=void 0,o=void 0;$a(t)?(r=t,o=e):oi(t)?(n=t,o=e):o=t;var i,a=o&&"Object"===o.returnType?"Object":"Array",u=o&&Jt(o),c=[],s=void 0,f=void 0,l=void 0;if(null!=r)(s=this._data.get(r))&&u&&!u(s)&&(s=void 0);else if(null!=n)for(var h=0,p=n.length;h<p;h++)null==(s=this._data.get(n[h]))||u&&!u(s)||c.push(s);else for(var v,d=0,y=(f=pi(oa(v=this._data).call(v))).length;d<y;d++)l=f[d],null==(s=this._data.get(l))||u&&!u(s)||c.push(s);if(o&&o.order&&null==r&&this._sort(c,o.order),o&&o.fields){var g=o.fields;if(null!=r&&null!=s)s=this._filterFields(s,g);else for(var m=0,b=c.length;m<b;m++)c[m]=this._filterFields(c[m],g)}if("Object"==a){for(var _={},w=0,O=c.length;w<O;w++){var x=c[w];_[x[this._idProp]]=x}return _}return null!=r?null!==(i=s)&&void 0!==i?i:null:c}},{key:"getIds",value:function(t){var e=this._data,r=t&&Jt(t),n=t&&t.order,o=pi(oa(e).call(e)),i=[];if(r)if(n){for(var a=[],u=0,c=o.length;u<c;u++){var s=o[u],f=this._data.get(s);null!=f&&r(f)&&a.push(f)}this._sort(a,n);for(var l=0,h=a.length;l<h;l++)i.push(a[l][this._idProp])}else for(var p=0,v=o.length;p<v;p++){var d=o[p],y=this._data.get(d);null!=y&&r(y)&&i.push(y[this._idProp])}else if(n){for(var g=[],m=0,b=o.length;m<b;m++){var _=o[m];g.push(e.get(_))}this._sort(g,n);for(var w=0,O=g.length;w<O;w++)i.push(g[w][this._idProp])}else for(var x=0,S=o.length;x<S;x++){var k=o[x],A=e.get(k);null!=A&&i.push(A[this._idProp])}return i}},{key:"getDataSet",value:function(){return this}},{key:"forEach",value:function(t,e){var r=e&&Jt(e),n=this._data,o=pi(oa(n).call(n));if(e&&e.order)for(var i=this.get(e),a=0,u=i.length;a<u;a++){var c=i[a];t(c,c[this._idProp])}else for(var s=0,f=o.length;s<f;s++){var l=o[s],h=this._data.get(l);null==h||r&&!r(h)||t(h,l)}}},{key:"map",value:function(t,e){for(var r=e&&Jt(e),n=[],o=this._data,i=pi(oa(o).call(o)),a=0,u=i.length;a<u;a++){var c=i[a],s=this._data.get(c);null==s||r&&!r(s)||n.push(t(s,c))}return e&&e.order&&this._sort(n,e.order),n}},{key:"_filterFields",value:function(t,e){var r;return t?te(r=oi(e)?e:ni(e)).call(r,(function(e,r){return e[r]=t[r],e}),{}):t}},{key:"_sort",value:function(t,e){if("string"==typeof e){var r=e;ta(t).call(t,(function(t,e){var n=t[r],o=e[r];return n>o?1:n<o?-1:0}))}else{if("function"!=typeof e)throw new TypeError("Order must be a function or a string");ta(t).call(t,e)}}},{key:"remove",value:function(t,e){for(var r=[],n=[],o=oi(t)?t:[t],i=0,a=o.length;i<a;i++){var u=this._remove(o[i]);if(u){var c=u[this._idProp];null!=c&&(r.push(c),n.push(u))}}return r.length&&this._trigger("remove",{items:r,oldData:n},e),r}},{key:"_remove",value:function(t){var e;if($a(t)?e=t:t&&"object"===ui(t)&&(e=t[this._idProp]),null!=e&&this._data.has(e)){var r=this._data.get(e)||null;return this._data.delete(e),--this.length,r}return null}},{key:"clear",value:function(t){for(var e,r=pi(oa(e=this._data).call(e)),n=[],o=0,i=r.length;o<i;o++)n.push(this._data.get(r[o]));return this._data.clear(),this.length=0,this._trigger("remove",{items:r,oldData:n},t),r}},{key:"max",value:function(t){var e,r,n=null,o=null,i=lu(Wi(e=this._data).call(e));try{for(i.s();!(r=i.n()).done;){var a=r.value,u=a[t];"number"==typeof u&&(null==o||u>o)&&(n=a,o=u)}}catch(t){i.e(t)}finally{i.f()}return n||null}},{key:"min",value:function(t){var e,r,n=null,o=null,i=lu(Wi(e=this._data).call(e));try{for(i.s();!(r=i.n()).done;){var a=r.value,u=a[t];"number"==typeof u&&(null==o||u<o)&&(n=a,o=u)}}catch(t){i.e(t)}finally{i.f()}return n||null}},{key:"distinct",value:function(t){for(var e=this._data,r=pi(oa(e).call(e)),n=[],o=0,i=0,a=r.length;i<a;i++){for(var u=r[i],c=e.get(u)[t],s=!1,f=0;f<o;f++)if(n[f]==c){s=!0;break}s||void 0===c||(n[o]=c,o++)}return n}},{key:"_addItem",value:function(t){var e=function(t,e){return null==t[e]&&(t[e]=Ja()),t}(t,this._idProp),r=e[this._idProp];if(this._data.has(r))throw new Error("Cannot add item: item with id "+r+" already exists");return this._data.set(r,e),++this.length,r}},{key:"_updateItem",value:function(t){var e=t[this._idProp];if(null==e)throw new Error("Cannot update item: item has no id (item: "+Ui(t)+")");var r=this._data.get(e);if(!r)throw new Error("Cannot update item: no item with id "+e+" found");return this._data.set(e,fu(fu({},r),t)),e}},{key:"stream",value:function(t){if(t){var e=this._data;return new cu(Yn({},Ri,Ci.mark((function r(){var n,o,i,a;return Ci.wrap((function(r){for(;;)switch(r.prev=r.next){case 0:n=lu(t),r.prev=1,n.s();case 3:if((o=n.n()).done){r.next=11;break}if(i=o.value,null==(a=e.get(i))){r.next=9;break}return r.next=9,[i,a];case 9:r.next=3;break;case 11:r.next=16;break;case 13:r.prev=13,r.t0=r.catch(1),n.e(r.t0);case 16:return r.prev=16,n.f(),r.finish(16);case 19:case"end":return r.stop()}}),r,null,[[1,13,16,19]])}))))}var r;return new cu(Yn({},Ri,ue(r=Li(this._data)).call(r,this._data)))}},{key:"idProp",get:function(){return this._idProp}}]),r}();function du(t,e){var r;if(void 0===gi||null==Dn(t)){if(oi(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return yu(t,e);var n=si(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return Jn(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return yu(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,o=function(){};return{s:o,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,u=!1;return{s:function(){r=Tn(t)},n:function(){var t=r.next();return a=t.done,t},e:function(t){u=!0,i=t},f:function(){try{a||null==r.return||r.return()}finally{if(u)throw i}}}}function yu(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}function gu(t){var e=function(){if("undefined"==typeof Reflect||!Ii)return!1;if(Ii.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Ii(Date,[],(function(){}))),!0}catch(t){return!1}}();return function(){var r,n=Ma(t);if(e){var o=Ma(this).constructor;r=Ii(n,arguments,o)}else r=n.apply(this,arguments);return Ca(this,r)}}var mu=function(t){Da(r,ou);var e=gu(r);function r(t,n){var o,i;return ce(this,r),(i=e.call(this)).length=0,i._ids=new iu,i._options=n||{},i._listener=ue(o=i._onEvent).call(o,La(i)),i.setData(t),i}return he(r,[{key:"setData",value:function(t){if(this._data){this._data.off&&this._data.off("*",this._listener);var e=this._data.getIds({filter:Jt(this._options)}),r=this._data.get(e);this._ids.clear(),this.length=0,this._trigger("remove",{items:e,oldData:r})}if(null!=t){this._data=t;for(var n=this._data.getIds({filter:Jt(this._options)}),o=0,i=n.length;o<i;o++){var a=n[o];this._ids.add(a)}this.length=n.length,this._trigger("add",{items:n})}else this._data=new vu;this._data.on&&this._data.on("*",this._listener)}},{key:"refresh",value:function(){for(var t=this._data.getIds({filter:Jt(this._options)}),e=pi(this._ids),r={},n=[],o=[],i=[],a=0,u=t.length;a<u;a++){var c=t[a];r[c]=!0,this._ids.has(c)||(n.push(c),this._ids.add(c))}for(var s=0,f=e.length;s<f;s++){var l=e[s],h=this._data.get(l);null==h?console.error("If you see this, report it please."):r[l]||(o.push(l),i.push(h),this._ids.delete(l))}this.length+=n.length-o.length,n.length&&this._trigger("add",{items:n}),o.length&&this._trigger("remove",{items:o,oldData:i})}},{key:"get",value:function(t,e){if(null==this._data)return null;var r,n=null;$a(t)||oi(t)?(n=t,r=e):r=t;var o=Io({},this._options,r),i=Jt(this._options),a=r&&Jt(r);return i&&a&&(o.filter=function(t){return i(t)&&a(t)}),null==n?this._data.get(o):this._data.get(n,o)}},{key:"getIds",value:function(t){if(this._data.length){var e,r=Jt(this._options),n=null!=t?Jt(t):null;return e=n?r?function(t){return r(t)&&n(t)}:n:r,this._data.getIds({filter:e,order:t&&t.order})}return[]}},{key:"forEach",value:function(t,e){if(this._data){var r,n,o=Jt(this._options),i=e&&Jt(e);n=i?o?function(t){return o(t)&&i(t)}:i:o,fo(r=this._data).call(r,t,{filter:n,order:e&&e.order})}}},{key:"map",value:function(t,e){if(this._data){var r,n,o=Jt(this._options),i=e&&Jt(e);return n=i?o?function(t){return o(t)&&i(t)}:i:o,Nt(r=this._data).call(r,t,{filter:n,order:e&&e.order})}return[]}},{key:"getDataSet",value:function(){return this._data.getDataSet()}},{key:"stream",value:function(t){var e;return this._data.stream(t||Yn({},Ri,ue(e=oa(this._ids)).call(e,this._ids)))}},{key:"dispose",value:function(){var t;(null===(t=this._data)||void 0===t?void 0:t.off)&&this._data.off("*",this._listener);var e,n="This data view has already been disposed of.",o={get:function(){throw new Error(n)},set:function(){throw new Error(n)},configurable:!1},i=du(ci(r.prototype));try{for(i.s();!(e=i.n()).done;){var a=e.value;ye(this,a,o)}}catch(t){i.e(t)}finally{i.f()}}},{key:"_onEvent",value:function(t,e,r){if(e&&e.items&&this._data){var n=e.items,o=[],i=[],a=[],u=[],c=[],s=[];switch(t){case"add":for(var f=0,l=n.length;f<l;f++){var h=n[f];this.get(h)&&(this._ids.add(h),o.push(h))}break;case"update":for(var p=0,v=n.length;p<v;p++){var d=n[p];this.get(d)?this._ids.has(d)?(i.push(d),c.push(e.data[p]),u.push(e.oldData[p])):(this._ids.add(d),o.push(d)):this._ids.has(d)&&(this._ids.delete(d),a.push(d),s.push(e.oldData[p]))}break;case"remove":for(var y=0,g=n.length;y<g;y++){var m=n[y];this._ids.has(m)&&(this._ids.delete(m),a.push(m),s.push(e.oldData[y]))}}this.length+=o.length-a.length,o.length&&this._trigger("add",{items:o},r),i.length&&this._trigger("update",{items:i,oldData:u,data:c},r),a.length&&this._trigger("remove",{items:a,oldData:s},r)}}},{key:"idProp",get:function(){return this.getDataSet().idProp}}]),r}();function bu(t,e){return"object"===ui(e)&&null!==e&&t===e.idProp&&"function"==typeof e.add&&"function"==typeof e.clear&&"function"==typeof e.distinct&&"function"==typeof fo(e)&&"function"==typeof e.get&&"function"==typeof e.getDataSet&&"function"==typeof e.getIds&&"number"==typeof e.length&&"function"==typeof Nt(e)&&"function"==typeof e.max&&"function"==typeof e.min&&"function"==typeof e.off&&"function"==typeof e.on&&"function"==typeof e.remove&&"function"==typeof e.setOptions&&"function"==typeof e.stream&&"function"==typeof e.update&&"function"==typeof e.updateOnly}function _u(t,e){return"object"===ui(e)&&null!==e&&t===e.idProp&&"function"==typeof fo(e)&&"function"==typeof e.get&&"function"==typeof e.getDataSet&&"function"==typeof e.getIds&&"number"==typeof e.length&&"function"==typeof Nt(e)&&"function"==typeof e.off&&"function"==typeof e.on&&"function"==typeof e.stream&&bu(t,e.getDataSet())}export{_i as DELETE,vu as DataSet,cu as DataStream,mu as DataView,nu as Queue,pe as createNewDataPipeFrom,bu as isDataSetLike,_u as isDataViewLike};
//# sourceMappingURL=vis-data.min.js.map
