/**
 * vis-data
 * http://visjs.org/
 *
 * Manage unstructured data using DataSet. Add, update, and remove data, and listen for changes in the data.
 *
 * @version 7.1.1
 * @date    2020-11-15T19:08:22.864Z
 *
 * @copyright (c) 2011-2017 Almende B.V, http://almende.com
 * @copyright (c) 2017-2019 visjs contributors, https://github.com/visjs
 *
 * @license
 * vis.js is dual licensed under both
 *
 *   1. The Apache 2.0 License
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *   and
 *
 *   2. The MIT License
 *      http://opensource.org/licenses/MIT
 *
 * vis.js may be distributed under either license.
 */
!function(t,e){"object"==typeof exports&&"undefined"!=typeof module?e(exports):"function"==typeof define&&define.amd?define(["exports"],e):e((t="undefined"!=typeof globalThis?globalThis:t||self).vis=t.vis||{})}(this,(function(t){var e="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};function r(t,e,r){return t(r={path:e,exports:{},require:function(t,e){return function(){throw new Error("Dynamic requires are not currently supported by @rollup/plugin-commonjs")}(null==e&&r.path)}},r.exports),r.exports}var n=function(t){return t&&t.Math==Math&&t},o=n("object"==typeof globalThis&&globalThis)||n("object"==typeof window&&window)||n("object"==typeof self&&self)||n("object"==typeof e&&e)||function(){return this}()||Function("return this")(),i=function(t){try{return!!t()}catch(t){return!0}},a=!i((function(){return 7!=Object.defineProperty({},1,{get:function(){return 7}})[1]})),u={}.propertyIsEnumerable,c=Object.getOwnPropertyDescriptor,s={f:c&&!u.call({1:2},1)?function(t){var e=c(this,t);return!!e&&e.enumerable}:u},f=function(t,e){return{enumerable:!(1&t),configurable:!(2&t),writable:!(4&t),value:e}},l={}.toString,h=function(t){return l.call(t).slice(8,-1)},p="".split,v=i((function(){return!Object("z").propertyIsEnumerable(0)}))?function(t){return"String"==h(t)?p.call(t,""):Object(t)}:Object,d=function(t){if(null==t)throw TypeError("Can't call method on "+t);return t},y=function(t){return v(d(t))},g=function(t){return"object"==typeof t?null!==t:"function"==typeof t},m=function(t,e){if(!g(t))return t;var r,n;if(e&&"function"==typeof(r=t.toString)&&!g(n=r.call(t)))return n;if("function"==typeof(r=t.valueOf)&&!g(n=r.call(t)))return n;if(!e&&"function"==typeof(r=t.toString)&&!g(n=r.call(t)))return n;throw TypeError("Can't convert object to primitive value")},b={}.hasOwnProperty,_=function(t,e){return b.call(t,e)},w=o.document,O=g(w)&&g(w.createElement),x=function(t){return O?w.createElement(t):{}},S=!a&&!i((function(){return 7!=Object.defineProperty(x("div"),"a",{get:function(){return 7}}).a})),k=Object.getOwnPropertyDescriptor,j={f:a?k:function(t,e){if(t=y(t),e=m(e,!0),S)try{return k(t,e)}catch(t){}if(_(t,e))return f(!s.f.call(t,e),t[e])}},A=/#|\.prototype\./,E=function(t,e){var r=I[P(t)];return r==D||r!=T&&("function"==typeof e?i(e):!!e)},P=E.normalize=function(t){return String(t).replace(A,".").toLowerCase()},I=E.data={},T=E.NATIVE="N",D=E.POLYFILL="P",L=E,C={},R=function(t){if("function"!=typeof t)throw TypeError(String(t)+" is not a function");return t},M=function(t,e,r){if(R(t),void 0===e)return t;switch(r){case 0:return function(){return t.call(e)};case 1:return function(r){return t.call(e,r)};case 2:return function(r,n){return t.call(e,r,n)};case 3:return function(r,n,o){return t.call(e,r,n,o)}}return function(){return t.apply(e,arguments)}},F=function(t){if(!g(t))throw TypeError(String(t)+" is not an object");return t},N=Object.defineProperty,q={f:a?N:function(t,e,r){if(F(t),e=m(e,!0),F(r),S)try{return N(t,e,r)}catch(t){}if("get"in r||"set"in r)throw TypeError("Accessors not supported");return"value"in r&&(t[e]=r.value),t}},G=a?function(t,e,r){return q.f(t,e,f(1,r))}:function(t,e,r){return t[e]=r,t},z=j.f,U=function(t){var e=function(e,r,n){if(this instanceof t){switch(arguments.length){case 0:return new t;case 1:return new t(e);case 2:return new t(e,r)}return new t(e,r,n)}return t.apply(this,arguments)};return e.prototype=t.prototype,e},V=function(t,e){var r,n,i,a,u,c,s,f,l=t.target,h=t.global,p=t.stat,v=t.proto,d=h?o:p?o[l]:(o[l]||{}).prototype,y=h?C:C[l]||(C[l]={}),g=y.prototype;for(i in e)r=!L(h?i:l+(p?".":"#")+i,t.forced)&&d&&_(d,i),u=y[i],r&&(c=t.noTargetGet?(f=z(d,i))&&f.value:d[i]),a=r&&c?c:e[i],r&&typeof u==typeof a||(s=t.bind&&r?M(a,o):t.wrap&&r?U(a):v&&"function"==typeof a?M(Function.call,a):a,(t.sham||a&&a.sham||u&&u.sham)&&G(s,"sham",!0),y[i]=s,v&&(_(C,n=l+"Prototype")||G(C,n,{}),C[n][i]=a,t.real&&g&&!g[i]&&G(g,i,a)))},J=Array.isArray||function(t){return"Array"==h(t)},$=Math.ceil,W=Math.floor,B=function(t){return isNaN(t=+t)?0:(t>0?W:$)(t)},K=Math.min,Q=function(t){return t>0?K(B(t),9007199254740991):0},Y=function(t,e,r,n,o,i,a,u){for(var c,s=o,f=0,l=!!a&&M(a,u,3);f<n;){if(f in r){if(c=l?l(r[f],f,e):r[f],i>0&&J(c))s=Y(t,e,c,Q(c.length),s,i-1)-1;else{if(s>=9007199254740991)throw TypeError("Exceed the acceptable array length");t[s]=c}s++}f++}return s},H=Y,X=function(t){return Object(d(t))},Z="__core-js_shared__",tt=o[Z]||function(t,e){try{G(o,t,e)}catch(r){o[t]=e}return e}(Z,{}),et=r((function(t){(t.exports=function(t,e){return tt[t]||(tt[t]=void 0!==e?e:{})})("versions",[]).push({version:"3.7.0",mode:"pure",copyright:"© 2020 Denis Pushkarev (zloirock.ru)"})})),rt=0,nt=Math.random(),ot=function(t){return"Symbol("+String(void 0===t?"":t)+")_"+(++rt+nt).toString(36)},it=!!Object.getOwnPropertySymbols&&!i((function(){return!String(Symbol())})),at=it&&!Symbol.sham&&"symbol"==typeof Symbol.iterator,ut=et("wks"),ct=o.Symbol,st=at?ct:ct&&ct.withoutSetter||ot,ft=function(t){return _(ut,t)||(it&&_(ct,t)?ut[t]=ct[t]:ut[t]=st("Symbol."+t)),ut[t]},lt=ft("species"),ht=function(t,e){var r;return J(t)&&("function"!=typeof(r=t.constructor)||r!==Array&&!J(r.prototype)?g(r)&&null===(r=r[lt])&&(r=void 0):r=void 0),new(void 0===r?Array:r)(0===e?0:e)};V({target:"Array",proto:!0},{flatMap:function(t){var e,r=X(this),n=Q(r.length);return R(t),(e=ht(r,0)).length=H(e,r,r,n,0,1,t,arguments.length>1?arguments[1]:void 0),e}});var pt,vt,dt=function(t){return C[t+"Prototype"]},yt=dt("Array").flatMap,gt=Array.prototype,mt=function(t){var e=t.flatMap;return t===gt||t instanceof Array&&e===gt.flatMap?yt:e},bt=[].push,_t=function(t){var e=1==t,r=2==t,n=3==t,o=4==t,i=6==t,a=5==t||i;return function(u,c,s,f){for(var l,h,p=X(u),d=v(p),y=M(c,s,3),g=Q(d.length),m=0,b=f||ht,_=e?b(u,g):r?b(u,0):void 0;g>m;m++)if((a||m in d)&&(h=y(l=d[m],m,p),t))if(e)_[m]=h;else if(h)switch(t){case 3:return!0;case 5:return l;case 6:return m;case 2:bt.call(_,l)}else if(o)return!1;return i?-1:n||o?o:_}},wt={forEach:_t(0),map:_t(1),filter:_t(2),some:_t(3),every:_t(4),find:_t(5),findIndex:_t(6)},Ot=function(t){return"function"==typeof t?t:void 0},xt=function(t,e){return arguments.length<2?Ot(C[t])||Ot(o[t]):C[t]&&C[t][e]||o[t]&&o[t][e]},St=xt("navigator","userAgent")||"",kt=o.process,jt=kt&&kt.versions,At=jt&&jt.v8;At?vt=(pt=At.split("."))[0]+pt[1]:St&&(!(pt=St.match(/Edge\/(\d+)/))||pt[1]>=74)&&(pt=St.match(/Chrome\/(\d+)/))&&(vt=pt[1]);var Et=vt&&+vt,Pt=ft("species"),It=function(t){return Et>=51||!i((function(){var e=[];return(e.constructor={})[Pt]=function(){return{foo:1}},1!==e[t](Boolean).foo}))},Tt=Object.defineProperty,Dt={},Lt=function(t){throw t},Ct=function(t,e){if(_(Dt,t))return Dt[t];e||(e={});var r=[][t],n=!!_(e,"ACCESSORS")&&e.ACCESSORS,o=_(e,0)?e[0]:Lt,u=_(e,1)?e[1]:void 0;return Dt[t]=!!r&&!i((function(){if(n&&!a)return!0;var t={length:-1};n?Tt(t,1,{enumerable:!0,get:Lt}):t[1]=1,r.call(t,o,u)}))},Rt=wt.map,Mt=It("map"),Ft=Ct("map");V({target:"Array",proto:!0,forced:!Mt||!Ft},{map:function(t){return Rt(this,t,arguments.length>1?arguments[1]:void 0)}});var Nt=dt("Array").map,qt=Array.prototype,Gt=function(t){var e=t.map;return t===qt||t instanceof Array&&e===qt.map?Nt:e},zt=wt.filter,Ut=It("filter"),Vt=Ct("filter");V({target:"Array",proto:!0,forced:!Ut||!Vt},{filter:function(t){return zt(this,t,arguments.length>1?arguments[1]:void 0)}});var Jt=dt("Array").filter,$t=Array.prototype,Wt=function(t){var e=t.filter;return t===$t||t instanceof Array&&e===$t.filter?Jt:e},Bt=function(t){return function(e,r,n,o){R(r);var i=X(e),a=v(i),u=Q(i.length),c=t?u-1:0,s=t?-1:1;if(n<2)for(;;){if(c in a){o=a[c],c+=s;break}if(c+=s,t?c<0:u<=c)throw TypeError("Reduce of empty array with no initial value")}for(;t?c>=0:u>c;c+=s)c in a&&(o=r(o,a[c],c,i));return o}},Kt={left:Bt(!1),right:Bt(!0)},Qt=function(t,e){var r=[][t];return!!r&&i((function(){r.call(null,e||function(){throw 1},1)}))},Yt="process"==h(o.process),Ht=Kt.left,Xt=Qt("reduce"),Zt=Ct("reduce",{1:0});V({target:"Array",proto:!0,forced:!Xt||!Zt||!Yt&&Et>79&&Et<83},{reduce:function(t){return Ht(this,t,arguments.length,arguments.length>1?arguments[1]:void 0)}});var te=dt("Array").reduce,ee=Array.prototype,re=function(t){var e=t.reduce;return t===ee||t instanceof Array&&e===ee.reduce?te:e},ne=[].slice,oe={},ie=function(t,e,r){if(!(e in oe)){for(var n=[],o=0;o<e;o++)n[o]="a["+o+"]";oe[e]=Function("C,a","return new C("+n.join(",")+")")}return oe[e](t,r)},ae=Function.bind||function(t){var e=R(this),r=ne.call(arguments,1),n=function(){var o=r.concat(ne.call(arguments));return this instanceof n?ie(e,o.length,o):e.apply(t,o)};return g(e.prototype)&&(n.prototype=e.prototype),n};V({target:"Function",proto:!0},{bind:ae});var ue=dt("Function").bind,ce=Function.prototype,se=function(t){var e=t.bind;return t===ce||t instanceof Function&&e===ce.bind?ue:e};var fe=function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")};V({target:"Object",stat:!0,forced:!a,sham:!a},{defineProperty:q.f});var le=r((function(t){var e=C.Object,r=t.exports=function(t,r,n){return e.defineProperty(t,r,n)};e.defineProperty.sham&&(r.sham=!0)})),he=le;function pe(t,e){for(var r=0;r<e.length;r++){var n=e[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),he(t,n.key,n)}}var ve=function(t,e,r){return e&&pe(t.prototype,e),r&&pe(t,r),t};var de=function(){function t(e,r,n){var o,i,a;fe(this,t),this._source=e,this._transformers=r,this._target=n,this._listeners={add:se(o=this._add).call(o,this),remove:se(i=this._remove).call(i,this),update:se(a=this._update).call(a,this)}}return ve(t,[{key:"all",value:function(){return this._target.update(this._transformItems(this._source.get())),this}},{key:"start",value:function(){return this._source.on("add",this._listeners.add),this._source.on("remove",this._listeners.remove),this._source.on("update",this._listeners.update),this}},{key:"stop",value:function(){return this._source.off("add",this._listeners.add),this._source.off("remove",this._listeners.remove),this._source.off("update",this._listeners.update),this}},{key:"_transformItems",value:function(t){var e;return re(e=this._transformers).call(e,(function(t,e){return e(t)}),t)}},{key:"_add",value:function(t,e){null!=e&&this._target.add(this._transformItems(this._source.get(e.items)))}},{key:"_update",value:function(t,e){null!=e&&this._target.update(this._transformItems(this._source.get(e.items)))}},{key:"_remove",value:function(t,e){null!=e&&this._target.remove(this._transformItems(e.oldData))}}]),t}(),ye=function(){function t(e){fe(this,t),this._source=e,this._transformers=[]}return ve(t,[{key:"filter",value:function(t){return this._transformers.push((function(e){return Wt(e).call(e,t)})),this}},{key:"map",value:function(t){return this._transformers.push((function(e){return Gt(e).call(e,t)})),this}},{key:"flatMap",value:function(t){return this._transformers.push((function(e){return mt(e).call(e,t)})),this}},{key:"to",value:function(t){return new de(this._source,this._transformers,t)}}]),t}(),ge=le,me=Math.max,be=Math.min,_e=function(t,e){var r=B(t);return r<0?me(r+e,0):be(r,e)},we=function(t){return function(e,r,n){var o,i=y(e),a=Q(i.length),u=_e(n,a);if(t&&r!=r){for(;a>u;)if((o=i[u++])!=o)return!0}else for(;a>u;u++)if((t||u in i)&&i[u]===r)return t||u||0;return!t&&-1}},Oe={includes:we(!0),indexOf:we(!1)},xe={},Se=Oe.indexOf,ke=function(t,e){var r,n=y(t),o=0,i=[];for(r in n)!_(xe,r)&&_(n,r)&&i.push(r);for(;e.length>o;)_(n,r=e[o++])&&(~Se(i,r)||i.push(r));return i},je=["constructor","hasOwnProperty","isPrototypeOf","propertyIsEnumerable","toLocaleString","toString","valueOf"],Ae=Object.keys||function(t){return ke(t,je)},Ee=a?Object.defineProperties:function(t,e){F(t);for(var r,n=Ae(e),o=n.length,i=0;o>i;)q.f(t,r=n[i++],e[r]);return t};V({target:"Object",stat:!0,forced:!a,sham:!a},{defineProperties:Ee});var Pe=r((function(t){var e=C.Object,r=t.exports=function(t,r){return e.defineProperties(t,r)};e.defineProperties.sham&&(r.sham=!0)})),Ie=je.concat("length","prototype"),Te={f:Object.getOwnPropertyNames||function(t){return ke(t,Ie)}},De={f:Object.getOwnPropertySymbols},Le=xt("Reflect","ownKeys")||function(t){var e=Te.f(F(t)),r=De.f;return r?e.concat(r(t)):e},Ce=function(t,e,r){var n=m(e);n in t?q.f(t,n,f(0,r)):t[n]=r};V({target:"Object",stat:!0,sham:!a},{getOwnPropertyDescriptors:function(t){for(var e,r,n=y(t),o=j.f,i=Le(n),a={},u=0;i.length>u;)void 0!==(r=o(n,e=i[u++]))&&Ce(a,e,r);return a}});var Re=C.Object.getOwnPropertyDescriptors,Me=j.f,Fe=i((function(){Me(1)}));V({target:"Object",stat:!0,forced:!a||Fe,sham:!a},{getOwnPropertyDescriptor:function(t,e){return Me(y(t),e)}});var Ne,qe=r((function(t){var e=C.Object,r=t.exports=function(t,r){return e.getOwnPropertyDescriptor(t,r)};e.getOwnPropertyDescriptor.sham&&(r.sham=!0)})),Ge=xt("document","documentElement"),ze=et("keys"),Ue=function(t){return ze[t]||(ze[t]=ot(t))},Ve=Ue("IE_PROTO"),Je=function(){},$e=function(t){return"<script>"+t+"</"+"script>"},We=function(){try{Ne=document.domain&&new ActiveXObject("htmlfile")}catch(t){}var t,e;We=Ne?function(t){t.write($e("")),t.close();var e=t.parentWindow.Object;return t=null,e}(Ne):((e=x("iframe")).style.display="none",Ge.appendChild(e),e.src=String("javascript:"),(t=e.contentWindow.document).open(),t.write($e("document.F=Object")),t.close(),t.F);for(var r=je.length;r--;)delete We.prototype[je[r]];return We()};xe[Ve]=!0;var Be=Object.create||function(t,e){var r;return null!==t?(Je.prototype=F(t),r=new Je,Je.prototype=null,r[Ve]=t):r=We(),void 0===e?r:Ee(r,e)},Ke=Te.f,Qe={}.toString,Ye="object"==typeof window&&window&&Object.getOwnPropertyNames?Object.getOwnPropertyNames(window):[],He={f:function(t){return Ye&&"[object Window]"==Qe.call(t)?function(t){try{return Ke(t)}catch(t){return Ye.slice()}}(t):Ke(y(t))}},Xe=function(t,e,r,n){n&&n.enumerable?t[e]=r:G(t,e,r)},Ze={f:ft},tr=q.f,er=function(t){var e=C.Symbol||(C.Symbol={});_(e,t)||tr(e,t,{value:Ze.f(t)})},rr={};rr[ft("toStringTag")]="z";var nr="[object z]"===String(rr),or=ft("toStringTag"),ir="Arguments"==h(function(){return arguments}()),ar=nr?h:function(t){var e,r,n;return void 0===t?"Undefined":null===t?"Null":"string"==typeof(r=function(t,e){try{return t[e]}catch(t){}}(e=Object(t),or))?r:ir?h(e):"Object"==(n=h(e))&&"function"==typeof e.callee?"Arguments":n},ur=nr?{}.toString:function(){return"[object "+ar(this)+"]"},cr=q.f,sr=ft("toStringTag"),fr=function(t,e,r,n){if(t){var o=r?t:t.prototype;_(o,sr)||cr(o,sr,{configurable:!0,value:e}),n&&!nr&&G(o,"toString",ur)}},lr=Function.toString;"function"!=typeof tt.inspectSource&&(tt.inspectSource=function(t){return lr.call(t)});var hr,pr,vr,dr=tt.inspectSource,yr=o.WeakMap,gr="function"==typeof yr&&/native code/.test(dr(yr)),mr=o.WeakMap;if(gr){var br=tt.state||(tt.state=new mr),_r=br.get,wr=br.has,Or=br.set;hr=function(t,e){return e.facade=t,Or.call(br,t,e),e},pr=function(t){return _r.call(br,t)||{}},vr=function(t){return wr.call(br,t)}}else{var xr=Ue("state");xe[xr]=!0,hr=function(t,e){return e.facade=t,G(t,xr,e),e},pr=function(t){return _(t,xr)?t[xr]:{}},vr=function(t){return _(t,xr)}}var Sr={set:hr,get:pr,has:vr,enforce:function(t){return vr(t)?pr(t):hr(t,{})},getterFor:function(t){return function(e){var r;if(!g(e)||(r=pr(e)).type!==t)throw TypeError("Incompatible receiver, "+t+" required");return r}}},kr=wt.forEach,jr=Ue("hidden"),Ar="Symbol",Er=ft("toPrimitive"),Pr=Sr.set,Ir=Sr.getterFor(Ar),Tr=Object.prototype,Dr=o.Symbol,Lr=xt("JSON","stringify"),Cr=j.f,Rr=q.f,Mr=He.f,Fr=s.f,Nr=et("symbols"),qr=et("op-symbols"),Gr=et("string-to-symbol-registry"),zr=et("symbol-to-string-registry"),Ur=et("wks"),Vr=o.QObject,Jr=!Vr||!Vr.prototype||!Vr.prototype.findChild,$r=a&&i((function(){return 7!=Be(Rr({},"a",{get:function(){return Rr(this,"a",{value:7}).a}})).a}))?function(t,e,r){var n=Cr(Tr,e);n&&delete Tr[e],Rr(t,e,r),n&&t!==Tr&&Rr(Tr,e,n)}:Rr,Wr=function(t,e){var r=Nr[t]=Be(Dr.prototype);return Pr(r,{type:Ar,tag:t,description:e}),a||(r.description=e),r},Br=at?function(t){return"symbol"==typeof t}:function(t){return Object(t)instanceof Dr},Kr=function(t,e,r){t===Tr&&Kr(qr,e,r),F(t);var n=m(e,!0);return F(r),_(Nr,n)?(r.enumerable?(_(t,jr)&&t[jr][n]&&(t[jr][n]=!1),r=Be(r,{enumerable:f(0,!1)})):(_(t,jr)||Rr(t,jr,f(1,{})),t[jr][n]=!0),$r(t,n,r)):Rr(t,n,r)},Qr=function(t,e){F(t);var r=y(e),n=Ae(r).concat(Zr(r));return kr(n,(function(e){a&&!Yr.call(r,e)||Kr(t,e,r[e])})),t},Yr=function(t){var e=m(t,!0),r=Fr.call(this,e);return!(this===Tr&&_(Nr,e)&&!_(qr,e))&&(!(r||!_(this,e)||!_(Nr,e)||_(this,jr)&&this[jr][e])||r)},Hr=function(t,e){var r=y(t),n=m(e,!0);if(r!==Tr||!_(Nr,n)||_(qr,n)){var o=Cr(r,n);return!o||!_(Nr,n)||_(r,jr)&&r[jr][n]||(o.enumerable=!0),o}},Xr=function(t){var e=Mr(y(t)),r=[];return kr(e,(function(t){_(Nr,t)||_(xe,t)||r.push(t)})),r},Zr=function(t){var e=t===Tr,r=Mr(e?qr:y(t)),n=[];return kr(r,(function(t){!_(Nr,t)||e&&!_(Tr,t)||n.push(Nr[t])})),n};if(it||(Xe((Dr=function(){if(this instanceof Dr)throw TypeError("Symbol is not a constructor");var t=arguments.length&&void 0!==arguments[0]?String(arguments[0]):void 0,e=ot(t),r=function(t){this===Tr&&r.call(qr,t),_(this,jr)&&_(this[jr],e)&&(this[jr][e]=!1),$r(this,e,f(1,t))};return a&&Jr&&$r(Tr,e,{configurable:!0,set:r}),Wr(e,t)}).prototype,"toString",(function(){return Ir(this).tag})),Xe(Dr,"withoutSetter",(function(t){return Wr(ot(t),t)})),s.f=Yr,q.f=Kr,j.f=Hr,Te.f=He.f=Xr,De.f=Zr,Ze.f=function(t){return Wr(ft(t),t)},a&&Rr(Dr.prototype,"description",{configurable:!0,get:function(){return Ir(this).description}})),V({global:!0,wrap:!0,forced:!it,sham:!it},{Symbol:Dr}),kr(Ae(Ur),(function(t){er(t)})),V({target:Ar,stat:!0,forced:!it},{for:function(t){var e=String(t);if(_(Gr,e))return Gr[e];var r=Dr(e);return Gr[e]=r,zr[r]=e,r},keyFor:function(t){if(!Br(t))throw TypeError(t+" is not a symbol");if(_(zr,t))return zr[t]},useSetter:function(){Jr=!0},useSimple:function(){Jr=!1}}),V({target:"Object",stat:!0,forced:!it,sham:!a},{create:function(t,e){return void 0===e?Be(t):Qr(Be(t),e)},defineProperty:Kr,defineProperties:Qr,getOwnPropertyDescriptor:Hr}),V({target:"Object",stat:!0,forced:!it},{getOwnPropertyNames:Xr,getOwnPropertySymbols:Zr}),V({target:"Object",stat:!0,forced:i((function(){De.f(1)}))},{getOwnPropertySymbols:function(t){return De.f(X(t))}}),Lr){var tn=!it||i((function(){var t=Dr();return"[null]"!=Lr([t])||"{}"!=Lr({a:t})||"{}"!=Lr(Object(t))}));V({target:"JSON",stat:!0,forced:tn},{stringify:function(t,e,r){for(var n,o=[t],i=1;arguments.length>i;)o.push(arguments[i++]);if(n=e,(g(e)||void 0!==t)&&!Br(t))return J(e)||(e=function(t,e){if("function"==typeof n&&(e=n.call(this,t,e)),!Br(e))return e}),o[1]=e,Lr.apply(null,o)}})}Dr.prototype[Er]||G(Dr.prototype,Er,Dr.prototype.valueOf),fr(Dr,Ar),xe[jr]=!0;var en,rn,nn,on=C.Object.getOwnPropertySymbols,an={},un=!i((function(){function t(){}return t.prototype.constructor=null,Object.getPrototypeOf(new t)!==t.prototype})),cn=Ue("IE_PROTO"),sn=Object.prototype,fn=un?Object.getPrototypeOf:function(t){return t=X(t),_(t,cn)?t[cn]:"function"==typeof t.constructor&&t instanceof t.constructor?t.constructor.prototype:t instanceof Object?sn:null},ln=(ft("iterator"),!1);[].keys&&("next"in(nn=[].keys())?(rn=fn(fn(nn)))!==Object.prototype&&(en=rn):ln=!0),null==en&&(en={});var hn={IteratorPrototype:en,BUGGY_SAFARI_ITERATORS:ln},pn=hn.IteratorPrototype,vn=function(){return this},dn=Object.setPrototypeOf||("__proto__"in{}?function(){var t,e=!1,r={};try{(t=Object.getOwnPropertyDescriptor(Object.prototype,"__proto__").set).call(r,[]),e=r instanceof Array}catch(t){}return function(r,n){return F(r),function(t){if(!g(t)&&null!==t)throw TypeError("Can't set "+String(t)+" as a prototype")}(n),e?t.call(r,n):r.__proto__=n,r}}():void 0),yn=hn.IteratorPrototype,gn=hn.BUGGY_SAFARI_ITERATORS,mn=ft("iterator"),bn="keys",_n="values",wn="entries",On=function(){return this},xn=function(t,e,r,n,o,i,a){!function(t,e,r){var n=e+" Iterator";t.prototype=Be(pn,{next:f(1,r)}),fr(t,n,!1,!0),an[n]=vn}(r,e,n);var u,c,s,l=function(t){if(t===o&&y)return y;if(!gn&&t in v)return v[t];switch(t){case bn:case _n:case wn:return function(){return new r(this,t)}}return function(){return new r(this)}},h=e+" Iterator",p=!1,v=t.prototype,d=v[mn]||v["@@iterator"]||o&&v[o],y=!gn&&d||l(o),g="Array"==e&&v.entries||d;if(g&&(u=fn(g.call(new t)),yn!==Object.prototype&&u.next&&(fr(u,h,!0,!0),an[h]=On)),o==_n&&d&&d.name!==_n&&(p=!0,y=function(){return d.call(this)}),a&&v[mn]!==y&&G(v,mn,y),an[e]=y,o)if(c={values:l(_n),keys:i?y:l(bn),entries:l(wn)},a)for(s in c)(gn||p||!(s in v))&&Xe(v,s,c[s]);else V({target:e,proto:!0,forced:gn||p},c);return c},Sn="Array Iterator",kn=Sr.set,jn=Sr.getterFor(Sn);xn(Array,"Array",(function(t,e){kn(this,{type:Sn,target:y(t),index:0,kind:e})}),(function(){var t=jn(this),e=t.target,r=t.kind,n=t.index++;return!e||n>=e.length?(t.target=void 0,{value:void 0,done:!0}):"keys"==r?{value:n,done:!1}:"values"==r?{value:e[n],done:!1}:{value:[n,e[n]],done:!1}}),"values");an.Arguments=an.Array;var An=ft("toStringTag");for(var En in{CSSRuleList:0,CSSStyleDeclaration:0,CSSValueList:0,ClientRectList:0,DOMRectList:0,DOMStringList:0,DOMTokenList:1,DataTransferItemList:0,FileList:0,HTMLAllCollection:0,HTMLCollection:0,HTMLFormElement:0,HTMLSelectElement:0,MediaList:0,MimeTypeArray:0,NamedNodeMap:0,NodeList:1,PaintRequestList:0,Plugin:0,PluginArray:0,SVGLengthList:0,SVGNumberList:0,SVGPathSegList:0,SVGPointList:0,SVGStringList:0,SVGTransformList:0,SourceBufferList:0,StyleSheetList:0,TextTrackCueList:0,TextTrackList:0,TouchList:0}){var Pn=o[En],In=Pn&&Pn.prototype;In&&ar(In)!==An&&G(In,An,En),an[En]=an.Array}var Tn=function(t){return function(e,r){var n,o,i=String(d(e)),a=B(r),u=i.length;return a<0||a>=u?t?"":void 0:(n=i.charCodeAt(a))<55296||n>56319||a+1===u||(o=i.charCodeAt(a+1))<56320||o>57343?t?i.charAt(a):n:t?i.slice(a,a+2):o-56320+(n-55296<<10)+65536}},Dn={codeAt:Tn(!1),charAt:Tn(!0)}.charAt,Ln="String Iterator",Cn=Sr.set,Rn=Sr.getterFor(Ln);xn(String,"String",(function(t){Cn(this,{type:Ln,string:String(t),index:0})}),(function(){var t,e=Rn(this),r=e.string,n=e.index;return n>=r.length?{value:void 0,done:!0}:(t=Dn(r,n),e.index+=t.length,{value:t,done:!1})}));var Mn=ft("iterator"),Fn=function(t){if(null!=t)return t[Mn]||t["@@iterator"]||an[ar(t)]},Nn=function(t){var e=Fn(t);if("function"!=typeof e)throw TypeError(String(t)+" is not iterable");return F(e.call(t))},qn=Fn,Gn=function(t){var e=t.return;if(void 0!==e)return F(e.call(t)).value},zn=function(t,e,r,n){try{return n?e(F(r)[0],r[1]):e(r)}catch(e){throw Gn(t),e}},Un=ft("iterator"),Vn=Array.prototype,Jn=function(t){return void 0!==t&&(an.Array===t||Vn[Un]===t)},$n=ft("iterator"),Wn=!1;try{var Bn=0,Kn={next:function(){return{done:!!Bn++}},return:function(){Wn=!0}};Kn[$n]=function(){return this},Array.from(Kn,(function(){throw 2}))}catch(t){}var Qn=!function(t,e){if(!e&&!Wn)return!1;var r=!1;try{var n={};n[$n]=function(){return{next:function(){return{done:r=!0}}}},t(n)}catch(t){}return r}((function(t){Array.from(t)}));V({target:"Array",stat:!0,forced:Qn},{from:function(t){var e,r,n,o,i,a,u=X(t),c="function"==typeof this?this:Array,s=arguments.length,f=s>1?arguments[1]:void 0,l=void 0!==f,h=Fn(u),p=0;if(l&&(f=M(f,s>2?arguments[2]:void 0,2)),null==h||c==Array&&Jn(h))for(r=new c(e=Q(u.length));e>p;p++)a=l?f(u[p],p):u[p],Ce(r,p,a);else for(i=(o=h.call(u)).next,r=new c;!(n=i.call(o)).done;p++)a=l?zn(o,f,[n.value,p],!0):n.value,Ce(r,p,a);return r.length=p,r}});var Yn=C.Array.from,Hn=Yn;V({target:"Object",stat:!0,sham:!a},{create:Be});var Xn=C.Object,Zn=function(t,e){return Xn.create(t,e)},to=Zn;var eo,ro=function(t,e,r){return e in t?he(t,e,{value:r,enumerable:!0,configurable:!0,writable:!0}):t[e]=r,t},no="\t\n\v\f\r                　\u2028\u2029\ufeff",oo="["+no+"]",io=RegExp("^"+oo+oo+"*"),ao=RegExp(oo+oo+"*$"),uo=function(t){return function(e){var r=String(d(e));return 1&t&&(r=r.replace(io,"")),2&t&&(r=r.replace(ao,"")),r}},co={start:uo(1),end:uo(2),trim:uo(3)},so=co.trim;V({target:"String",proto:!0,forced:(eo="trim",i((function(){return!!no[eo]()||"​᠎"!="​᠎"[eo]()||no[eo].name!==eo})))},{trim:function(){return so(this)}});dt("String").trim;var fo=wt.forEach,lo=Qt("forEach"),ho=Ct("forEach"),po=lo&&ho?[].forEach:function(t){return fo(this,t,arguments.length>1?arguments[1]:void 0)};V({target:"Array",proto:!0,forced:[].forEach!=po},{forEach:po});var vo=dt("Array").forEach,yo=Array.prototype,go={DOMTokenList:!0,NodeList:!0},mo=function(t){var e=t.forEach;return t===yo||t instanceof Array&&e===yo.forEach||go.hasOwnProperty(ar(t))?vo:e},bo=co.trim,_o=o.parseInt,wo=/^[+-]?0[Xx]/,Oo=8!==_o(no+"08")||22!==_o(no+"0x16")?function(t,e){var r=bo(String(t));return _o(r,e>>>0||(wo.test(r)?16:10))}:_o;V({global:!0,forced:parseInt!=Oo},{parseInt:Oo});var xo=s.f,So=function(t){return function(e){for(var r,n=y(e),o=Ae(n),i=o.length,u=0,c=[];i>u;)r=o[u++],a&&!xo.call(n,r)||c.push(t?[r,n[r]]:n[r]);return c}},ko={entries:So(!0),values:So(!1)}.values;V({target:"Object",stat:!0},{values:function(t){return ko(t)}});C.Object.values;var jo=i((function(){fn(1)}));V({target:"Object",stat:!0,forced:jo,sham:!un},{getPrototypeOf:function(t){return fn(X(t))}});var Ao=C.Object.getPrototypeOf,Eo=Oe.indexOf,Po=[].indexOf,Io=!!Po&&1/[1].indexOf(1,-0)<0,To=Qt("indexOf"),Do=Ct("indexOf",{ACCESSORS:!0,1:0});V({target:"Array",proto:!0,forced:Io||!To||!Do},{indexOf:function(t){return Io?Po.apply(this,arguments)||0:Eo(this,t,arguments.length>1?arguments[1]:void 0)}});dt("Array").indexOf;var Lo=Object.assign,Co=Object.defineProperty,Ro=!Lo||i((function(){if(a&&1!==Lo({b:1},Lo(Co({},"a",{enumerable:!0,get:function(){Co(this,"b",{value:3,enumerable:!1})}}),{b:2})).b)return!0;var t={},e={},r=Symbol(),n="abcdefghijklmnopqrst";return t[r]=7,n.split("").forEach((function(t){e[t]=t})),7!=Lo({},t)[r]||Ae(Lo({},e)).join("")!=n}))?function(t,e){for(var r=X(t),n=arguments.length,o=1,i=De.f,u=s.f;n>o;)for(var c,f=v(arguments[o++]),l=i?Ae(f).concat(i(f)):Ae(f),h=l.length,p=0;h>p;)c=l[p++],a&&!u.call(f,c)||(r[c]=f[c]);return r}:Lo;V({target:"Object",stat:!0,forced:Object.assign!==Ro},{assign:Ro});var Mo=C.Object.assign;V({target:"Array",stat:!0},{isArray:J});var Fo=C.Array.isArray,No=Fo;var qo=function(t){if(No(t))return t},Go=ft("iterator"),zo=function(t){var e=Object(t);return void 0!==e[Go]||"@@iterator"in e||an.hasOwnProperty(ar(e))},Uo=ft("isConcatSpreadable"),Vo=9007199254740991,Jo="Maximum allowed index exceeded",$o=Et>=51||!i((function(){var t=[];return t[Uo]=!1,t.concat()[0]!==t})),Wo=It("concat"),Bo=function(t){if(!g(t))return!1;var e=t[Uo];return void 0!==e?!!e:J(t)};V({target:"Array",proto:!0,forced:!$o||!Wo},{concat:function(t){var e,r,n,o,i,a=X(this),u=ht(a,0),c=0;for(e=-1,n=arguments.length;e<n;e++)if(Bo(i=-1===e?a:arguments[e])){if(c+(o=Q(i.length))>Vo)throw TypeError(Jo);for(r=0;r<o;r++,c++)r in i&&Ce(u,c,i[r])}else{if(c>=Vo)throw TypeError(Jo);Ce(u,c++,i)}return u.length=c,u}}),er("asyncIterator"),er("hasInstance"),er("isConcatSpreadable"),er("iterator"),er("match"),er("matchAll"),er("replace"),er("search"),er("species"),er("split"),er("toPrimitive"),er("toStringTag"),er("unscopables"),fr(o.JSON,"JSON",!0);var Ko=C.Symbol;er("asyncDispose"),er("dispose"),er("observable"),er("patternMatch"),er("replaceAll");var Qo=Ko;var Yo=function(t,e){if(void 0!==Qo&&zo(Object(t))){var r=[],n=!0,o=!1,i=void 0;try{for(var a,u=Nn(t);!(n=(a=u.next()).done)&&(r.push(a.value),!e||r.length!==e);n=!0);}catch(t){o=!0,i=t}finally{try{n||null==u.return||u.return()}finally{if(o)throw i}}return r}},Ho=Yn,Xo=It("slice"),Zo=Ct("slice",{ACCESSORS:!0,0:0,1:2}),ti=ft("species"),ei=[].slice,ri=Math.max;V({target:"Array",proto:!0,forced:!Xo||!Zo},{slice:function(t,e){var r,n,o,i=y(this),a=Q(i.length),u=_e(t,a),c=_e(void 0===e?a:e,a);if(J(i)&&("function"!=typeof(r=i.constructor)||r!==Array&&!J(r.prototype)?g(r)&&null===(r=r[ti])&&(r=void 0):r=void 0,r===Array||void 0===r))return ei.call(i,u,c);for(n=new(void 0===r?Array:r)(ri(c-u,0)),o=0;u<c;u++,o++)u in i&&Ce(n,o,i[u]);return n.length=o,n}});var ni=dt("Array").slice,oi=Array.prototype,ii=function(t){var e=t.slice;return t===oi||t instanceof Array&&e===oi.slice?ni:e},ai=ii;var ui=function(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n};var ci=function(t,e){var r;if(t){if("string"==typeof t)return ui(t,e);var n=ai(r=Object.prototype.toString.call(t)).call(r,8,-1);return"Object"===n&&t.constructor&&(n=t.constructor.name),"Map"===n||"Set"===n?Ho(t):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?ui(t,e):void 0}};var si=function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")};var fi=function(t,e){return qo(t)||Yo(t,e)||ci(t,e)||si()};V({target:"Date",stat:!0},{now:function(){return(new Date).getTime()}});C.Date.now;var li=i((function(){Ae(1)}));V({target:"Object",stat:!0,forced:li},{keys:function(t){return Ae(X(t))}});var hi=C.Object.keys,pi=Fo,vi=Ze.f("iterator"),di=vi,yi=r((function(t){function e(r){return t.exports=e="function"==typeof Qo&&"symbol"==typeof di?function(t){return typeof t}:function(t){return t&&"function"==typeof Qo&&t.constructor===Qo&&t!==Qo.prototype?"symbol":typeof t},e(r)}t.exports=e}));V({target:"Reflect",stat:!0},{ownKeys:Le});var gi=C.Reflect.ownKeys,mi=ii;var bi=function(t){if(No(t))return ui(t)};var _i=function(t){if(void 0!==Qo&&zo(Object(t)))return Ho(t)};var wi=function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")};var Oi=function(t){return bi(t)||_i(t)||ci(t)||wi()},xi=dt("Array").concat,Si=Array.prototype,ki=function(t){var e=t.concat;return t===Si||t instanceof Array&&e===Si.concat?xi:e},ji=Ko;function Ai(t,e){var r;if(void 0===ji||null==qn(t)){if(pi(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return Ei(t,e);var n=mi(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return Hn(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Ei(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,o=function(){};return{s:o,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,u=!1;return{s:function(){r=Nn(t)},n:function(){var t=r.next();return a=t.done,t},e:function(t){u=!0,i=t},f:function(){try{a||null==r.return||r.return()}finally{if(u)throw i}}}}function Ei(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}
/**
	 * vis-util
	 * https://github.com/visjs/vis-util
	 *
	 * utilitie collection for visjs
	 *
	 * @version 4.3.4
	 * @date    2020-08-01T15:11:53.524Z
	 *
	 * @copyright (c) 2011-2017 Almende B.V, http://almende.com
	 * @copyright (c) 2017-2019 visjs contributors, https://github.com/visjs
	 *
	 * @license
	 * vis.js is dual licensed under both
	 *
	 *   1. The Apache 2.0 License
	 *      http://www.apache.org/licenses/LICENSE-2.0
	 *
	 *   and
	 *
	 *   2. The MIT License
	 *      http://opensource.org/licenses/MIT
	 *
	 * vis.js may be distributed under either license.
	 */var Pi=ji("DELETE");function Ii(){var t=Ti.apply(void 0,arguments);return Li(t),t}function Ti(){for(var t=arguments.length,e=new Array(t),r=0;r<t;r++)e[r]=arguments[r];if(e.length<2)return e[0];var n;if(e.length>2)return Ti.apply(void 0,ki(n=[Ii(e[0],e[1])]).call(n,Oi(mi(e).call(e,2))));var o,i=e[0],a=e[1],u=Ai(gi(a));try{for(u.s();!(o=u.n()).done;){var c=o.value;Object.prototype.propertyIsEnumerable.call(a,c)&&(a[c]===Pi?delete i[c]:null===i[c]||null===a[c]||"object"!==yi(i[c])||"object"!==yi(a[c])||pi(i[c])||pi(a[c])?i[c]=Di(a[c]):i[c]=Ti(i[c],a[c]))}}catch(t){u.e(t)}finally{u.f()}return i}function Di(t){return pi(t)?Gt(t).call(t,(function(t){return Di(t)})):"object"===yi(t)&&null!==t?Ti({},t):t}function Li(t){for(var e=0,r=hi(t);e<r.length;e++){var n=r[e];t[n]===Pi?delete t[n]:"object"===yi(t[n])&&null!==t[n]&&Li(t[n])}}var Ci=xt("Reflect","construct"),Ri=i((function(){function t(){}return!(Ci((function(){}),[],t)instanceof t)})),Mi=!i((function(){Ci((function(){}))})),Fi=Ri||Mi;V({target:"Reflect",stat:!0,forced:Fi,sham:Fi},{construct:function(t,e){R(t),F(e);var r=arguments.length<3?t:R(arguments[2]);if(Mi&&!Ri)return Ci(t,e,r);if(t==r){switch(e.length){case 0:return new t;case 1:return new t(e[0]);case 2:return new t(e[0],e[1]);case 3:return new t(e[0],e[1],e[2]);case 4:return new t(e[0],e[1],e[2],e[3])}var n=[null];return n.push.apply(n,e),new(ae.apply(t,n))}var o=r.prototype,i=Be(g(o)?o:Object.prototype),a=Function.apply.call(t,i,e);return g(a)?a:i}});var Ni=C.Reflect.construct,qi=dt("Array").entries,Gi=Array.prototype,zi={DOMTokenList:!0,NodeList:!0},Ui=function(t){var e=t.entries;return t===Gi||t instanceof Array&&e===Gi.entries||zi.hasOwnProperty(ar(t))?qi:e},Vi=r((function(t){var e=function(t){var e,r=Object.prototype,n=r.hasOwnProperty,o="function"==typeof Symbol?Symbol:{},i=o.iterator||"@@iterator",a=o.asyncIterator||"@@asyncIterator",u=o.toStringTag||"@@toStringTag";function c(t,e,r){return Object.defineProperty(t,e,{value:r,enumerable:!0,configurable:!0,writable:!0}),t[e]}try{c({},"")}catch(t){c=function(t,e,r){return t[e]=r}}function s(t,e,r,n){var o=e&&e.prototype instanceof y?e:y,i=Object.create(o.prototype),a=new E(n||[]);return i._invoke=function(t,e,r){var n=l;return function(o,i){if(n===p)throw new Error("Generator is already running");if(n===v){if("throw"===o)throw i;return I()}for(r.method=o,r.arg=i;;){var a=r.delegate;if(a){var u=k(a,r);if(u){if(u===d)continue;return u}}if("next"===r.method)r.sent=r._sent=r.arg;else if("throw"===r.method){if(n===l)throw n=v,r.arg;r.dispatchException(r.arg)}else"return"===r.method&&r.abrupt("return",r.arg);n=p;var c=f(t,e,r);if("normal"===c.type){if(n=r.done?v:h,c.arg===d)continue;return{value:c.arg,done:r.done}}"throw"===c.type&&(n=v,r.method="throw",r.arg=c.arg)}}}(t,r,a),i}function f(t,e,r){try{return{type:"normal",arg:t.call(e,r)}}catch(t){return{type:"throw",arg:t}}}t.wrap=s;var l="suspendedStart",h="suspendedYield",p="executing",v="completed",d={};function y(){}function g(){}function m(){}var b={};b[i]=function(){return this};var _=Object.getPrototypeOf,w=_&&_(_(P([])));w&&w!==r&&n.call(w,i)&&(b=w);var O=m.prototype=y.prototype=Object.create(b);function x(t){["next","throw","return"].forEach((function(e){c(t,e,(function(t){return this._invoke(e,t)}))}))}function S(t,e){function r(o,i,a,u){var c=f(t[o],t,i);if("throw"!==c.type){var s=c.arg,l=s.value;return l&&"object"==typeof l&&n.call(l,"__await")?e.resolve(l.__await).then((function(t){r("next",t,a,u)}),(function(t){r("throw",t,a,u)})):e.resolve(l).then((function(t){s.value=t,a(s)}),(function(t){return r("throw",t,a,u)}))}u(c.arg)}var o;this._invoke=function(t,n){function i(){return new e((function(e,o){r(t,n,e,o)}))}return o=o?o.then(i,i):i()}}function k(t,r){var n=t.iterator[r.method];if(n===e){if(r.delegate=null,"throw"===r.method){if(t.iterator.return&&(r.method="return",r.arg=e,k(t,r),"throw"===r.method))return d;r.method="throw",r.arg=new TypeError("The iterator does not provide a 'throw' method")}return d}var o=f(n,t.iterator,r.arg);if("throw"===o.type)return r.method="throw",r.arg=o.arg,r.delegate=null,d;var i=o.arg;return i?i.done?(r[t.resultName]=i.value,r.next=t.nextLoc,"return"!==r.method&&(r.method="next",r.arg=e),r.delegate=null,d):i:(r.method="throw",r.arg=new TypeError("iterator result is not an object"),r.delegate=null,d)}function j(t){var e={tryLoc:t[0]};1 in t&&(e.catchLoc=t[1]),2 in t&&(e.finallyLoc=t[2],e.afterLoc=t[3]),this.tryEntries.push(e)}function A(t){var e=t.completion||{};e.type="normal",delete e.arg,t.completion=e}function E(t){this.tryEntries=[{tryLoc:"root"}],t.forEach(j,this),this.reset(!0)}function P(t){if(t){var r=t[i];if(r)return r.call(t);if("function"==typeof t.next)return t;if(!isNaN(t.length)){var o=-1,a=function r(){for(;++o<t.length;)if(n.call(t,o))return r.value=t[o],r.done=!1,r;return r.value=e,r.done=!0,r};return a.next=a}}return{next:I}}function I(){return{value:e,done:!0}}return g.prototype=O.constructor=m,m.constructor=g,g.displayName=c(m,u,"GeneratorFunction"),t.isGeneratorFunction=function(t){var e="function"==typeof t&&t.constructor;return!!e&&(e===g||"GeneratorFunction"===(e.displayName||e.name))},t.mark=function(t){return Object.setPrototypeOf?Object.setPrototypeOf(t,m):(t.__proto__=m,c(t,u,"GeneratorFunction")),t.prototype=Object.create(O),t},t.awrap=function(t){return{__await:t}},x(S.prototype),S.prototype[a]=function(){return this},t.AsyncIterator=S,t.async=function(e,r,n,o,i){void 0===i&&(i=Promise);var a=new S(s(e,r,n,o),i);return t.isGeneratorFunction(r)?a:a.next().then((function(t){return t.done?t.value:a.next()}))},x(O),c(O,u,"Generator"),O[i]=function(){return this},O.toString=function(){return"[object Generator]"},t.keys=function(t){var e=[];for(var r in t)e.push(r);return e.reverse(),function r(){for(;e.length;){var n=e.pop();if(n in t)return r.value=n,r.done=!1,r}return r.done=!0,r}},t.values=P,E.prototype={constructor:E,reset:function(t){if(this.prev=0,this.next=0,this.sent=this._sent=e,this.done=!1,this.delegate=null,this.method="next",this.arg=e,this.tryEntries.forEach(A),!t)for(var r in this)"t"===r.charAt(0)&&n.call(this,r)&&!isNaN(+r.slice(1))&&(this[r]=e)},stop:function(){this.done=!0;var t=this.tryEntries[0].completion;if("throw"===t.type)throw t.arg;return this.rval},dispatchException:function(t){if(this.done)throw t;var r=this;function o(n,o){return u.type="throw",u.arg=t,r.next=n,o&&(r.method="next",r.arg=e),!!o}for(var i=this.tryEntries.length-1;i>=0;--i){var a=this.tryEntries[i],u=a.completion;if("root"===a.tryLoc)return o("end");if(a.tryLoc<=this.prev){var c=n.call(a,"catchLoc"),s=n.call(a,"finallyLoc");if(c&&s){if(this.prev<a.catchLoc)return o(a.catchLoc,!0);if(this.prev<a.finallyLoc)return o(a.finallyLoc)}else if(c){if(this.prev<a.catchLoc)return o(a.catchLoc,!0)}else{if(!s)throw new Error("try statement without catch or finally");if(this.prev<a.finallyLoc)return o(a.finallyLoc)}}}},abrupt:function(t,e){for(var r=this.tryEntries.length-1;r>=0;--r){var o=this.tryEntries[r];if(o.tryLoc<=this.prev&&n.call(o,"finallyLoc")&&this.prev<o.finallyLoc){var i=o;break}}i&&("break"===t||"continue"===t)&&i.tryLoc<=e&&e<=i.finallyLoc&&(i=null);var a=i?i.completion:{};return a.type=t,a.arg=e,i?(this.method="next",this.next=i.finallyLoc,d):this.complete(a)},complete:function(t,e){if("throw"===t.type)throw t.arg;return"break"===t.type||"continue"===t.type?this.next=t.arg:"return"===t.type?(this.rval=this.arg=t.arg,this.method="return",this.next="end"):"normal"===t.type&&e&&(this.next=e),d},finish:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var r=this.tryEntries[e];if(r.finallyLoc===t)return this.complete(r.completion,r.afterLoc),A(r),d}},catch:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var r=this.tryEntries[e];if(r.tryLoc===t){var n=r.completion;if("throw"===n.type){var o=n.arg;A(r)}return o}}throw new Error("illegal catch attempt")},delegateYield:function(t,r,n){return this.delegate={iterator:P(t),resultName:r,nextLoc:n},"next"===this.method&&(this.arg=e),d}},t}(t.exports);try{regeneratorRuntime=e}catch(t){Function("r","regeneratorRuntime = r")(e)}})),Ji=vi,$i=xt("JSON","stringify"),Wi=/[\uD800-\uDFFF]/g,Bi=/^[\uD800-\uDBFF]$/,Ki=/^[\uDC00-\uDFFF]$/,Qi=function(t,e,r){var n=r.charAt(e-1),o=r.charAt(e+1);return Bi.test(t)&&!Ki.test(o)||Ki.test(t)&&!Bi.test(n)?"\\u"+t.charCodeAt(0).toString(16):t},Yi=i((function(){return'"\\udf06\\ud834"'!==$i("\udf06\ud834")||'"\\udead"'!==$i("\udead")}));$i&&V({target:"JSON",stat:!0,forced:Yi},{stringify:function(t,e,r){var n=$i.apply(null,arguments);return"string"==typeof n?n.replace(Wi,Qi):n}}),C.JSON||(C.JSON={stringify:JSON.stringify});var Hi=function(t,e,r){return C.JSON.stringify.apply(null,arguments)},Xi=dt("Array").values,Zi=Array.prototype,ta={DOMTokenList:!0,NodeList:!0},ea=function(t){var e=t.values;return t===Zi||t instanceof Array&&e===Zi.values||ta.hasOwnProperty(ar(t))?Xi:e},ra=[],na=ra.sort,oa=i((function(){ra.sort(void 0)})),ia=i((function(){ra.sort(null)})),aa=Qt("sort");V({target:"Array",proto:!0,forced:oa||!ia||!aa},{sort:function(t){return void 0===t?na.call(X(this)):na.call(X(this),R(t))}});var ua=dt("Array").sort,ca=Array.prototype,sa=function(t){var e=t.sort;return t===ca||t instanceof Array&&e===ca.sort?ua:e},fa=dt("Array").keys,la=Array.prototype,ha={DOMTokenList:!0,NodeList:!0},pa=function(t){var e=t.keys;return t===la||t instanceof Array&&e===la.keys||ha.hasOwnProperty(ar(t))?fa:e},va=wt.some,da=Qt("some"),ya=Ct("some");V({target:"Array",proto:!0,forced:!da||!ya},{some:function(t){return va(this,t,arguments.length>1?arguments[1]:void 0)}});var ga=dt("Array").some,ma=Array.prototype,ba=function(t){var e=t.some;return t===ma||t instanceof Array&&e===ma.some?ga:e},_a=!i((function(){return Object.isExtensible(Object.preventExtensions({}))})),wa=r((function(t){var e=q.f,r=ot("meta"),n=0,o=Object.isExtensible||function(){return!0},i=function(t){e(t,r,{value:{objectID:"O"+ ++n,weakData:{}}})},a=t.exports={REQUIRED:!1,fastKey:function(t,e){if(!g(t))return"symbol"==typeof t?t:("string"==typeof t?"S":"P")+t;if(!_(t,r)){if(!o(t))return"F";if(!e)return"E";i(t)}return t[r].objectID},getWeakData:function(t,e){if(!_(t,r)){if(!o(t))return!0;if(!e)return!1;i(t)}return t[r].weakData},onFreeze:function(t){return _a&&a.REQUIRED&&o(t)&&!_(t,r)&&i(t),t}};xe[r]=!0})),Oa=function(t,e){this.stopped=t,this.result=e},xa=function(t,e,r){var n,o,i,a,u,c,s,f=r&&r.that,l=!(!r||!r.AS_ENTRIES),h=!(!r||!r.IS_ITERATOR),p=!(!r||!r.INTERRUPTED),v=M(e,f,1+l+p),d=function(t){return n&&Gn(n),new Oa(!0,t)},y=function(t){return l?(F(t),p?v(t[0],t[1],d):v(t[0],t[1])):p?v(t,d):v(t)};if(h)n=t;else{if("function"!=typeof(o=Fn(t)))throw TypeError("Target is not iterable");if(Jn(o)){for(i=0,a=Q(t.length);a>i;i++)if((u=y(t[i]))&&u instanceof Oa)return u;return new Oa(!1)}n=o.call(t)}for(c=n.next;!(s=c.call(n)).done;){try{u=y(s.value)}catch(t){throw Gn(n),t}if("object"==typeof u&&u&&u instanceof Oa)return u}return new Oa(!1)},Sa=function(t,e,r){if(!(t instanceof e))throw TypeError("Incorrect "+(r?r+" ":"")+"invocation");return t},ka=q.f,ja=wt.forEach,Aa=Sr.set,Ea=Sr.getterFor,Pa=function(t,e,r){var n,u=-1!==t.indexOf("Map"),c=-1!==t.indexOf("Weak"),s=u?"set":"add",f=o[t],l=f&&f.prototype,h={};if(a&&"function"==typeof f&&(c||l.forEach&&!i((function(){(new f).entries().next()})))){n=e((function(e,r){Aa(Sa(e,n,t),{type:t,collection:new f}),null!=r&&xa(r,e[s],{that:e,AS_ENTRIES:u})}));var p=Ea(t);ja(["add","clear","delete","forEach","get","has","set","keys","values","entries"],(function(t){var e="add"==t||"set"==t;!(t in l)||c&&"clear"==t||G(n.prototype,t,(function(r,n){var o=p(this).collection;if(!e&&c&&!g(r))return"get"==t&&void 0;var i=o[t](0===r?0:r,n);return e?this:i}))})),c||ka(n.prototype,"size",{configurable:!0,get:function(){return p(this).collection.size}})}else n=r.getConstructor(e,t,u,s),wa.REQUIRED=!0;return fr(n,t,!1,!0),h[t]=n,V({global:!0,forced:!0},h),c||r.setStrong(n,t,u),n},Ia=function(t,e,r){for(var n in e)r&&r.unsafe&&t[n]?t[n]=e[n]:Xe(t,n,e[n],r);return t},Ta=ft("species"),Da=q.f,La=wa.fastKey,Ca=Sr.set,Ra=Sr.getterFor,Ma={getConstructor:function(t,e,r,n){var o=t((function(t,i){Sa(t,o,e),Ca(t,{type:e,index:Be(null),first:void 0,last:void 0,size:0}),a||(t.size=0),null!=i&&xa(i,t[n],{that:t,AS_ENTRIES:r})})),i=Ra(e),u=function(t,e,r){var n,o,u=i(t),s=c(t,e);return s?s.value=r:(u.last=s={index:o=La(e,!0),key:e,value:r,previous:n=u.last,next:void 0,removed:!1},u.first||(u.first=s),n&&(n.next=s),a?u.size++:t.size++,"F"!==o&&(u.index[o]=s)),t},c=function(t,e){var r,n=i(t),o=La(e);if("F"!==o)return n.index[o];for(r=n.first;r;r=r.next)if(r.key==e)return r};return Ia(o.prototype,{clear:function(){for(var t=i(this),e=t.index,r=t.first;r;)r.removed=!0,r.previous&&(r.previous=r.previous.next=void 0),delete e[r.index],r=r.next;t.first=t.last=void 0,a?t.size=0:this.size=0},delete:function(t){var e=this,r=i(e),n=c(e,t);if(n){var o=n.next,u=n.previous;delete r.index[n.index],n.removed=!0,u&&(u.next=o),o&&(o.previous=u),r.first==n&&(r.first=o),r.last==n&&(r.last=u),a?r.size--:e.size--}return!!n},forEach:function(t){for(var e,r=i(this),n=M(t,arguments.length>1?arguments[1]:void 0,3);e=e?e.next:r.first;)for(n(e.value,e.key,this);e&&e.removed;)e=e.previous},has:function(t){return!!c(this,t)}}),Ia(o.prototype,r?{get:function(t){var e=c(this,t);return e&&e.value},set:function(t,e){return u(this,0===t?0:t,e)}}:{add:function(t){return u(this,t=0===t?0:t,t)}}),a&&Da(o.prototype,"size",{get:function(){return i(this).size}}),o},setStrong:function(t,e,r){var n=e+" Iterator",o=Ra(e),i=Ra(n);xn(t,e,(function(t,e){Ca(this,{type:n,target:t,state:o(t),kind:e,last:void 0})}),(function(){for(var t=i(this),e=t.kind,r=t.last;r&&r.removed;)r=r.previous;return t.target&&(t.last=r=r?r.next:t.state.first)?"keys"==e?{value:r.key,done:!1}:"values"==e?{value:r.value,done:!1}:{value:[r.key,r.value],done:!1}:(t.target=void 0,{value:void 0,done:!0})}),r?"entries":"values",!r,!0),function(t){var e=xt(t),r=q.f;a&&e&&!e[Ta]&&r(e,Ta,{configurable:!0,get:function(){return this}})}(e)}},Fa=(Pa("Map",(function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}}),Ma),C.Map),Na=Zn;V({target:"Object",stat:!0},{setPrototypeOf:dn});var qa=C.Object.setPrototypeOf,Ga=r((function(t){function e(r,n){return t.exports=e=qa||function(t,e){return t.__proto__=e,t},e(r,n)}t.exports=e}));var za=function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=Na(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&Ga(t,e)};var Ua=function(t){if(void 0===t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return t};var Va=function(t,e){return!e||"object"!==yi(e)&&"function"!=typeof e?Ua(t):e},Ja=Ao,$a=r((function(t){function e(r){return t.exports=e=qa?Ja:function(t){return t.__proto__||Ja(t)},e(r)}t.exports=e})),Wa="undefined"!=typeof crypto&&crypto.getRandomValues&&crypto.getRandomValues.bind(crypto)||"undefined"!=typeof msCrypto&&"function"==typeof msCrypto.getRandomValues&&msCrypto.getRandomValues.bind(msCrypto),Ba=new Uint8Array(16);function Ka(){if(!Wa)throw new Error("crypto.getRandomValues() not supported. See https://github.com/uuidjs/uuid#getrandomvalues-not-supported");return Wa(Ba)}var Qa=/^(?:[0-9a-f]{8}-[0-9a-f]{4}-[1-5][0-9a-f]{3}-[89ab][0-9a-f]{3}-[0-9a-f]{12}|00000000-0000-0000-0000-000000000000)$/i;function Ya(t){return"string"==typeof t&&Qa.test(t)}for(var Ha=[],Xa=0;Xa<256;++Xa)Ha.push((Xa+256).toString(16).substr(1));function Za(t,e,r){var n=(t=t||{}).random||(t.rng||Ka)();if(n[6]=15&n[6]|64,n[8]=63&n[8]|128,e){r=r||0;for(var o=0;o<16;++o)e[r+o]=n[o];return e}return function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:0,r=(Ha[t[e+0]]+Ha[t[e+1]]+Ha[t[e+2]]+Ha[t[e+3]]+"-"+Ha[t[e+4]]+Ha[t[e+5]]+"-"+Ha[t[e+6]]+Ha[t[e+7]]+"-"+Ha[t[e+8]]+Ha[t[e+9]]+"-"+Ha[t[e+10]]+Ha[t[e+11]]+Ha[t[e+12]]+Ha[t[e+13]]+Ha[t[e+14]]+Ha[t[e+15]]).toLowerCase();if(!Ya(r))throw TypeError("Stringified UUID is invalid");return r}(n)}function tu(t){return"string"==typeof t||"number"==typeof t}var eu=It("splice"),ru=Ct("splice",{ACCESSORS:!0,0:0,1:2}),nu=Math.max,ou=Math.min,iu=9007199254740991,au="Maximum allowed length exceeded";V({target:"Array",proto:!0,forced:!eu||!ru},{splice:function(t,e){var r,n,o,i,a,u,c=X(this),s=Q(c.length),f=_e(t,s),l=arguments.length;if(0===l?r=n=0:1===l?(r=0,n=s-f):(r=l-2,n=ou(nu(B(e),0),s-f)),s+r-n>iu)throw TypeError(au);for(o=ht(c,n),i=0;i<n;i++)(a=f+i)in c&&Ce(o,i,c[a]);if(o.length=n,r<n){for(i=f;i<s-n;i++)u=i+r,(a=i+n)in c?c[u]=c[a]:delete c[u];for(i=s;i>s-n+r;i--)delete c[i-1]}else if(r>n)for(i=s-n;i>f;i--)u=i+r-1,(a=i+n-1)in c?c[u]=c[a]:delete c[u];for(i=0;i<r;i++)c[i+f]=arguments[i+2];return c.length=s-n+r,o}});var uu=dt("Array").splice,cu=Array.prototype,su=function(t){var e=t.splice;return t===cu||t instanceof Array&&e===cu.splice?uu:e},fu=[].slice,lu=/MSIE .\./.test(St),hu=function(t){return function(e,r){var n=arguments.length>2,o=n?fu.call(arguments,2):void 0;return t(n?function(){("function"==typeof e?e:Function(e)).apply(this,o)}:e,r)}};V({global:!0,bind:!0,forced:lu},{setTimeout:hu(o.setTimeout),setInterval:hu(o.setInterval)});var pu=C.setTimeout,vu=function(){function t(e){fe(this,t),this._queue=[],this._timeout=null,this._extended=null,this.delay=null,this.max=1/0,this.setOptions(e)}return ve(t,[{key:"setOptions",value:function(t){t&&void 0!==t.delay&&(this.delay=t.delay),t&&void 0!==t.max&&(this.max=t.max),this._flushIfNeeded()}},{key:"destroy",value:function(){if(this.flush(),this._extended){for(var t=this._extended.object,e=this._extended.methods,r=0;r<e.length;r++){var n=e[r];n.original?t[n.name]=n.original:delete t[n.name]}this._extended=null}}},{key:"replace",value:function(t,e){var r=this,n=t[e];if(!n)throw new Error("Method "+e+" undefined");t[e]=function(){for(var t=arguments.length,e=new Array(t),o=0;o<t;o++)e[o]=arguments[o];r.queue({args:e,fn:n,context:this})}}},{key:"queue",value:function(t){"function"==typeof t?this._queue.push({fn:t}):this._queue.push(t),this._flushIfNeeded()}},{key:"_flushIfNeeded",value:function(){var t=this;this._queue.length>this.max&&this.flush(),null!=this._timeout&&(clearTimeout(this._timeout),this._timeout=null),this.queue.length>0&&"number"==typeof this.delay&&(this._timeout=pu((function(){t.flush()}),this.delay))}},{key:"flush",value:function(){var t,e;mo(t=su(e=this._queue).call(e,0)).call(t,(function(t){t.fn.apply(t.context||t.fn,t.args||[])}))}}],[{key:"extend",value:function(e,r){var n=new t(r);if(void 0!==e.flush)throw new Error("Target object already has a property flush");e.flush=function(){n.flush()};var o=[{name:"flush",original:void 0}];if(r&&r.replace)for(var i=0;i<r.replace.length;i++){var a=r.replace[i];o.push({name:a,original:e[a]}),n.replace(e,a)}return n._extended={object:e,methods:o},n}}]),t}(),du=function(){function t(){fe(this,t),this._subscribers={"*":[],add:[],remove:[],update:[]},this.subscribe=t.prototype.on,this.unsubscribe=t.prototype.off}return ve(t,[{key:"_trigger",value:function(t,e,r){var n,o;if("*"===t)throw new Error("Cannot trigger event *");mo(n=ki(o=[]).call(o,Oi(this._subscribers[t]),Oi(this._subscribers["*"]))).call(n,(function(n){n(t,e,null!=r?r:null)}))}},{key:"on",value:function(t,e){"function"==typeof e&&this._subscribers[t].push(e)}},{key:"off",value:function(t,e){var r;this._subscribers[t]=Wt(r=this._subscribers[t]).call(r,(function(t){return t!==e}))}}]),t}(),yu=(Pa("Set",(function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}}),Ma),C.Set);function gu(t,e){var r;if(void 0===ji||null==qn(t)){if(pi(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return mu(t,e);var n=mi(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return Hn(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return mu(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,o=function(){};return{s:o,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,u=!1;return{s:function(){r=Nn(t)},n:function(){var t=r.next();return a=t.done,t},e:function(t){u=!0,i=t},f:function(){try{a||null==r.return||r.return()}finally{if(u)throw i}}}}function mu(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}var bu=function(){function t(e){fe(this,t),this._pairs=e}return ve(t,[{key:Ji,value:Vi.mark((function t(){var e,r,n,o,i;return Vi.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=gu(this._pairs),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=fi(r.value,2),o=n[0],i=n[1],t.next=7,[o,i];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"entries",value:Vi.mark((function t(){var e,r,n,o,i;return Vi.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=gu(this._pairs),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=fi(r.value,2),o=n[0],i=n[1],t.next=7,[o,i];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"keys",value:Vi.mark((function t(){var e,r,n,o;return Vi.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=gu(this._pairs),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=fi(r.value,1),o=n[0],t.next=7,o;case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"values",value:Vi.mark((function t(){var e,r,n,o;return Vi.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=gu(this._pairs),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=fi(r.value,2),o=n[1],t.next=7,o;case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"toIdArray",value:function(){var t;return Gt(t=Oi(this._pairs)).call(t,(function(t){return t[0]}))}},{key:"toItemArray",value:function(){var t;return Gt(t=Oi(this._pairs)).call(t,(function(t){return t[1]}))}},{key:"toEntryArray",value:function(){return Oi(this._pairs)}},{key:"toObjectMap",value:function(){var t,e=to(null),r=gu(this._pairs);try{for(r.s();!(t=r.n()).done;){var n=fi(t.value,2),o=n[0],i=n[1];e[o]=i}}catch(t){r.e(t)}finally{r.f()}return e}},{key:"toMap",value:function(){return new Fa(this._pairs)}},{key:"toIdSet",value:function(){return new yu(this.toIdArray())}},{key:"toItemSet",value:function(){return new yu(this.toItemArray())}},{key:"cache",value:function(){return new t(Oi(this._pairs))}},{key:"distinct",value:function(t){var e,r=new yu,n=gu(this._pairs);try{for(n.s();!(e=n.n()).done;){var o=fi(e.value,2),i=o[0],a=o[1];r.add(t(a,i))}}catch(t){n.e(t)}finally{n.f()}return r}},{key:"filter",value:function(e){var r=this._pairs;return new t(ro({},Ji,Vi.mark((function t(){var n,o,i,a,u;return Vi.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:n=gu(r),t.prev=1,n.s();case 3:if((o=n.n()).done){t.next=10;break}if(i=fi(o.value,2),a=i[0],u=i[1],!e(u,a)){t.next=8;break}return t.next=8,[a,u];case 8:t.next=3;break;case 10:t.next=15;break;case 12:t.prev=12,t.t0=t.catch(1),n.e(t.t0);case 15:return t.prev=15,n.f(),t.finish(15);case 18:case"end":return t.stop()}}),t,null,[[1,12,15,18]])}))))}},{key:"forEach",value:function(t){var e,r=gu(this._pairs);try{for(r.s();!(e=r.n()).done;){var n=fi(e.value,2),o=n[0];t(n[1],o)}}catch(t){r.e(t)}finally{r.f()}}},{key:"map",value:function(e){var r=this._pairs;return new t(ro({},Ji,Vi.mark((function t(){var n,o,i,a,u;return Vi.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:n=gu(r),t.prev=1,n.s();case 3:if((o=n.n()).done){t.next=9;break}return i=fi(o.value,2),a=i[0],u=i[1],t.next=7,[a,e(u,a)];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),n.e(t.t0);case 14:return t.prev=14,n.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,null,[[1,11,14,17]])}))))}},{key:"max",value:function(t){var e=Nn(this._pairs),r=e.next();if(r.done)return null;for(var n=r.value[1],o=t(r.value[1],r.value[0]);!(r=e.next()).done;){var i=fi(r.value,2),a=i[0],u=i[1],c=t(u,a);c>o&&(o=c,n=u)}return n}},{key:"min",value:function(t){var e=Nn(this._pairs),r=e.next();if(r.done)return null;for(var n=r.value[1],o=t(r.value[1],r.value[0]);!(r=e.next()).done;){var i=fi(r.value,2),a=i[0],u=i[1],c=t(u,a);c<o&&(o=c,n=u)}return n}},{key:"reduce",value:function(t,e){var r,n=gu(this._pairs);try{for(n.s();!(r=n.n()).done;){var o=fi(r.value,2),i=o[0];e=t(e,o[1],i)}}catch(t){n.e(t)}finally{n.f()}return e}},{key:"sort",value:function(e){var r=this;return new t(ro({},Ji,(function(){var t;return Nn(sa(t=Oi(r._pairs)).call(t,(function(t,r){var n=fi(t,2),o=n[0],i=n[1],a=fi(r,2),u=a[0],c=a[1];return e(i,c,o,u)})))})))}}]),t}();function _u(t,e){var r=hi(t);if(on){var n=on(t);e&&(n=Wt(n).call(n,(function(e){return qe(t,e).enumerable}))),r.push.apply(r,n)}return r}function wu(t){for(var e=1;e<arguments.length;e++){var r,n=null!=arguments[e]?arguments[e]:{};if(e%2)mo(r=_u(Object(n),!0)).call(r,(function(e){ro(t,e,n[e])}));else if(Re)Pe(t,Re(n));else{var o;mo(o=_u(Object(n))).call(o,(function(e){ge(t,e,qe(n,e))}))}}return t}function Ou(t,e){var r;if(void 0===ji||null==qn(t)){if(pi(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return xu(t,e);var n=mi(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return Hn(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return xu(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,o=function(){};return{s:o,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,u=!1;return{s:function(){r=Nn(t)},n:function(){var t=r.next();return a=t.done,t},e:function(t){u=!0,i=t},f:function(){try{a||null==r.return||r.return()}finally{if(u)throw i}}}}function xu(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}function Su(t){var e=function(){if("undefined"==typeof Reflect||!Ni)return!1;if(Ni.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Ni(Date,[],(function(){}))),!0}catch(t){return!1}}();return function(){var r,n=$a(t);if(e){var o=$a(this).constructor;r=Ni(n,arguments,o)}else r=n.apply(this,arguments);return Va(this,r)}}var ku=function(t){za(r,t);var e=Su(r);function r(t,n){var o;return fe(this,r),(o=e.call(this))._queue=null,t&&!pi(t)&&(n=t,t=[]),o._options=n||{},o._data=new Fa,o.length=0,o._idProp=o._options.fieldId||"id",t&&t.length&&o.add(t),o.setOptions(n),o}return ve(r,[{key:"setOptions",value:function(t){t&&void 0!==t.queue&&(!1===t.queue?this._queue&&(this._queue.destroy(),this._queue=null):(this._queue||(this._queue=vu.extend(this,{replace:["add","update","remove"]})),t.queue&&"object"===yi(t.queue)&&this._queue.setOptions(t.queue)))}},{key:"add",value:function(t,e){var r,n=this,o=[];if(pi(t)){var i=Gt(t).call(t,(function(t){return t[n._idProp]}));if(ba(i).call(i,(function(t){return n._data.has(t)})))throw new Error("A duplicate id was found in the parameter array.");for(var a=0,u=t.length;a<u;a++)r=this._addItem(t[a]),o.push(r)}else{if(!t||"object"!==yi(t))throw new Error("Unknown dataType");r=this._addItem(t),o.push(r)}return o.length&&this._trigger("add",{items:o},e),o}},{key:"update",value:function(t,e){var r=this,n=[],o=[],i=[],a=[],u=this._idProp,c=function(t){var e=t[u];if(null!=e&&r._data.has(e)){var c=t,s=Mo({},r._data.get(e)),f=r._updateItem(c);o.push(f),a.push(c),i.push(s)}else{var l=r._addItem(t);n.push(l)}};if(pi(t))for(var s=0,f=t.length;s<f;s++)t[s]&&"object"===yi(t[s])?c(t[s]):console.warn("Ignoring input item, which is not an object at index "+s);else{if(!t||"object"!==yi(t))throw new Error("Unknown dataType");c(t)}if(n.length&&this._trigger("add",{items:n},e),o.length){var l={items:o,oldData:i,data:a};this._trigger("update",l,e)}return ki(n).call(n,o)}},{key:"updateOnly",value:function(t,e){var r,n=this;pi(t)||(t=[t]);var o=Gt(r=Gt(t).call(t,(function(t){var e=n._data.get(t[n._idProp]);if(null==e)throw new Error("Updating non-existent items is not allowed.");return{oldData:e,update:t}}))).call(r,(function(t){var e=t.oldData,r=t.update,o=e[n._idProp],i=function(t){for(var e,r=arguments.length,n=new Array(r>1?r-1:0),o=1;o<r;o++)n[o-1]=arguments[o];return Ii.apply(void 0,ki(e=[{},t]).call(e,n))}(e,r);return n._data.set(o,i),{id:o,oldData:e,updatedData:i}}));if(o.length){var i={items:Gt(o).call(o,(function(t){return t.id})),oldData:Gt(o).call(o,(function(t){return t.oldData})),data:Gt(o).call(o,(function(t){return t.updatedData}))};return this._trigger("update",i,e),i.items}return[]}},{key:"get",value:function(t,e){var r=void 0,n=void 0,o=void 0;tu(t)?(r=t,o=e):pi(t)?(n=t,o=e):o=t;var i,a=o&&"Object"===o.returnType?"Object":"Array",u=o&&Wt(o),c=[],s=void 0,f=void 0,l=void 0;if(null!=r)(s=this._data.get(r))&&u&&!u(s)&&(s=void 0);else if(null!=n)for(var h=0,p=n.length;h<p;h++)null==(s=this._data.get(n[h]))||u&&!u(s)||c.push(s);else for(var v,d=0,y=(f=Oi(pa(v=this._data).call(v))).length;d<y;d++)l=f[d],null==(s=this._data.get(l))||u&&!u(s)||c.push(s);if(o&&o.order&&null==r&&this._sort(c,o.order),o&&o.fields){var g=o.fields;if(null!=r&&null!=s)s=this._filterFields(s,g);else for(var m=0,b=c.length;m<b;m++)c[m]=this._filterFields(c[m],g)}if("Object"==a){for(var _={},w=0,O=c.length;w<O;w++){var x=c[w];_[x[this._idProp]]=x}return _}return null!=r?null!==(i=s)&&void 0!==i?i:null:c}},{key:"getIds",value:function(t){var e=this._data,r=t&&Wt(t),n=t&&t.order,o=Oi(pa(e).call(e)),i=[];if(r)if(n){for(var a=[],u=0,c=o.length;u<c;u++){var s=o[u],f=this._data.get(s);null!=f&&r(f)&&a.push(f)}this._sort(a,n);for(var l=0,h=a.length;l<h;l++)i.push(a[l][this._idProp])}else for(var p=0,v=o.length;p<v;p++){var d=o[p],y=this._data.get(d);null!=y&&r(y)&&i.push(y[this._idProp])}else if(n){for(var g=[],m=0,b=o.length;m<b;m++){var _=o[m];g.push(e.get(_))}this._sort(g,n);for(var w=0,O=g.length;w<O;w++)i.push(g[w][this._idProp])}else for(var x=0,S=o.length;x<S;x++){var k=o[x],j=e.get(k);null!=j&&i.push(j[this._idProp])}return i}},{key:"getDataSet",value:function(){return this}},{key:"forEach",value:function(t,e){var r=e&&Wt(e),n=this._data,o=Oi(pa(n).call(n));if(e&&e.order)for(var i=this.get(e),a=0,u=i.length;a<u;a++){var c=i[a];t(c,c[this._idProp])}else for(var s=0,f=o.length;s<f;s++){var l=o[s],h=this._data.get(l);null==h||r&&!r(h)||t(h,l)}}},{key:"map",value:function(t,e){for(var r=e&&Wt(e),n=[],o=this._data,i=Oi(pa(o).call(o)),a=0,u=i.length;a<u;a++){var c=i[a],s=this._data.get(c);null==s||r&&!r(s)||n.push(t(s,c))}return e&&e.order&&this._sort(n,e.order),n}},{key:"_filterFields",value:function(t,e){var r;return t?re(r=pi(e)?e:hi(e)).call(r,(function(e,r){return e[r]=t[r],e}),{}):t}},{key:"_sort",value:function(t,e){if("string"==typeof e){var r=e;sa(t).call(t,(function(t,e){var n=t[r],o=e[r];return n>o?1:n<o?-1:0}))}else{if("function"!=typeof e)throw new TypeError("Order must be a function or a string");sa(t).call(t,e)}}},{key:"remove",value:function(t,e){for(var r=[],n=[],o=pi(t)?t:[t],i=0,a=o.length;i<a;i++){var u=this._remove(o[i]);if(u){var c=u[this._idProp];null!=c&&(r.push(c),n.push(u))}}return r.length&&this._trigger("remove",{items:r,oldData:n},e),r}},{key:"_remove",value:function(t){var e;if(tu(t)?e=t:t&&"object"===yi(t)&&(e=t[this._idProp]),null!=e&&this._data.has(e)){var r=this._data.get(e)||null;return this._data.delete(e),--this.length,r}return null}},{key:"clear",value:function(t){for(var e,r=Oi(pa(e=this._data).call(e)),n=[],o=0,i=r.length;o<i;o++)n.push(this._data.get(r[o]));return this._data.clear(),this.length=0,this._trigger("remove",{items:r,oldData:n},t),r}},{key:"max",value:function(t){var e,r,n=null,o=null,i=Ou(ea(e=this._data).call(e));try{for(i.s();!(r=i.n()).done;){var a=r.value,u=a[t];"number"==typeof u&&(null==o||u>o)&&(n=a,o=u)}}catch(t){i.e(t)}finally{i.f()}return n||null}},{key:"min",value:function(t){var e,r,n=null,o=null,i=Ou(ea(e=this._data).call(e));try{for(i.s();!(r=i.n()).done;){var a=r.value,u=a[t];"number"==typeof u&&(null==o||u<o)&&(n=a,o=u)}}catch(t){i.e(t)}finally{i.f()}return n||null}},{key:"distinct",value:function(t){for(var e=this._data,r=Oi(pa(e).call(e)),n=[],o=0,i=0,a=r.length;i<a;i++){for(var u=r[i],c=e.get(u)[t],s=!1,f=0;f<o;f++)if(n[f]==c){s=!0;break}s||void 0===c||(n[o]=c,o++)}return n}},{key:"_addItem",value:function(t){var e=function(t,e){return null==t[e]&&(t[e]=Za()),t}(t,this._idProp),r=e[this._idProp];if(this._data.has(r))throw new Error("Cannot add item: item with id "+r+" already exists");return this._data.set(r,e),++this.length,r}},{key:"_updateItem",value:function(t){var e=t[this._idProp];if(null==e)throw new Error("Cannot update item: item has no id (item: "+Hi(t)+")");var r=this._data.get(e);if(!r)throw new Error("Cannot update item: no item with id "+e+" found");return this._data.set(e,wu(wu({},r),t)),e}},{key:"stream",value:function(t){if(t){var e=this._data;return new bu(ro({},Ji,Vi.mark((function r(){var n,o,i,a;return Vi.wrap((function(r){for(;;)switch(r.prev=r.next){case 0:n=Ou(t),r.prev=1,n.s();case 3:if((o=n.n()).done){r.next=11;break}if(i=o.value,null==(a=e.get(i))){r.next=9;break}return r.next=9,[i,a];case 9:r.next=3;break;case 11:r.next=16;break;case 13:r.prev=13,r.t0=r.catch(1),n.e(r.t0);case 16:return r.prev=16,n.f(),r.finish(16);case 19:case"end":return r.stop()}}),r,null,[[1,13,16,19]])}))))}var r;return new bu(ro({},Ji,se(r=Ui(this._data)).call(r,this._data)))}},{key:"idProp",get:function(){return this._idProp}}]),r}(du);function ju(t,e){var r;if(void 0===ji||null==qn(t)){if(pi(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return Au(t,e);var n=mi(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return Hn(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Au(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,o=function(){};return{s:o,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,u=!1;return{s:function(){r=Nn(t)},n:function(){var t=r.next();return a=t.done,t},e:function(t){u=!0,i=t},f:function(){try{a||null==r.return||r.return()}finally{if(u)throw i}}}}function Au(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}function Eu(t){var e=function(){if("undefined"==typeof Reflect||!Ni)return!1;if(Ni.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Ni(Date,[],(function(){}))),!0}catch(t){return!1}}();return function(){var r,n=$a(t);if(e){var o=$a(this).constructor;r=Ni(n,arguments,o)}else r=n.apply(this,arguments);return Va(this,r)}}var Pu=function(t){za(r,t);var e=Eu(r);function r(t,n){var o,i;return fe(this,r),(i=e.call(this)).length=0,i._ids=new yu,i._options=n||{},i._listener=se(o=i._onEvent).call(o,Ua(i)),i.setData(t),i}return ve(r,[{key:"setData",value:function(t){if(this._data){this._data.off&&this._data.off("*",this._listener);var e=this._data.getIds({filter:Wt(this._options)}),r=this._data.get(e);this._ids.clear(),this.length=0,this._trigger("remove",{items:e,oldData:r})}if(null!=t){this._data=t;for(var n=this._data.getIds({filter:Wt(this._options)}),o=0,i=n.length;o<i;o++){var a=n[o];this._ids.add(a)}this.length=n.length,this._trigger("add",{items:n})}else this._data=new ku;this._data.on&&this._data.on("*",this._listener)}},{key:"refresh",value:function(){for(var t=this._data.getIds({filter:Wt(this._options)}),e=Oi(this._ids),r={},n=[],o=[],i=[],a=0,u=t.length;a<u;a++){var c=t[a];r[c]=!0,this._ids.has(c)||(n.push(c),this._ids.add(c))}for(var s=0,f=e.length;s<f;s++){var l=e[s],h=this._data.get(l);null==h?console.error("If you see this, report it please."):r[l]||(o.push(l),i.push(h),this._ids.delete(l))}this.length+=n.length-o.length,n.length&&this._trigger("add",{items:n}),o.length&&this._trigger("remove",{items:o,oldData:i})}},{key:"get",value:function(t,e){if(null==this._data)return null;var r,n=null;tu(t)||pi(t)?(n=t,r=e):r=t;var o=Mo({},this._options,r),i=Wt(this._options),a=r&&Wt(r);return i&&a&&(o.filter=function(t){return i(t)&&a(t)}),null==n?this._data.get(o):this._data.get(n,o)}},{key:"getIds",value:function(t){if(this._data.length){var e,r=Wt(this._options),n=null!=t?Wt(t):null;return e=n?r?function(t){return r(t)&&n(t)}:n:r,this._data.getIds({filter:e,order:t&&t.order})}return[]}},{key:"forEach",value:function(t,e){if(this._data){var r,n,o=Wt(this._options),i=e&&Wt(e);n=i?o?function(t){return o(t)&&i(t)}:i:o,mo(r=this._data).call(r,t,{filter:n,order:e&&e.order})}}},{key:"map",value:function(t,e){if(this._data){var r,n,o=Wt(this._options),i=e&&Wt(e);return n=i?o?function(t){return o(t)&&i(t)}:i:o,Gt(r=this._data).call(r,t,{filter:n,order:e&&e.order})}return[]}},{key:"getDataSet",value:function(){return this._data.getDataSet()}},{key:"stream",value:function(t){var e;return this._data.stream(t||ro({},Ji,se(e=pa(this._ids)).call(e,this._ids)))}},{key:"dispose",value:function(){var t;(null===(t=this._data)||void 0===t?void 0:t.off)&&this._data.off("*",this._listener);var e,n="This data view has already been disposed of.",o={get:function(){throw new Error(n)},set:function(){throw new Error(n)},configurable:!1},i=ju(gi(r.prototype));try{for(i.s();!(e=i.n()).done;){var a=e.value;ge(this,a,o)}}catch(t){i.e(t)}finally{i.f()}}},{key:"_onEvent",value:function(t,e,r){if(e&&e.items&&this._data){var n=e.items,o=[],i=[],a=[],u=[],c=[],s=[];switch(t){case"add":for(var f=0,l=n.length;f<l;f++){var h=n[f];this.get(h)&&(this._ids.add(h),o.push(h))}break;case"update":for(var p=0,v=n.length;p<v;p++){var d=n[p];this.get(d)?this._ids.has(d)?(i.push(d),c.push(e.data[p]),u.push(e.oldData[p])):(this._ids.add(d),o.push(d)):this._ids.has(d)&&(this._ids.delete(d),a.push(d),s.push(e.oldData[p]))}break;case"remove":for(var y=0,g=n.length;y<g;y++){var m=n[y];this._ids.has(m)&&(this._ids.delete(m),a.push(m),s.push(e.oldData[y]))}}this.length+=o.length-a.length,o.length&&this._trigger("add",{items:o},r),i.length&&this._trigger("update",{items:i,oldData:u,data:c},r),a.length&&this._trigger("remove",{items:a,oldData:s},r)}}},{key:"idProp",get:function(){return this.getDataSet().idProp}}]),r}(du);function Iu(t,e){return"object"===yi(e)&&null!==e&&t===e.idProp&&"function"==typeof e.add&&"function"==typeof e.clear&&"function"==typeof e.distinct&&"function"==typeof mo(e)&&"function"==typeof e.get&&"function"==typeof e.getDataSet&&"function"==typeof e.getIds&&"number"==typeof e.length&&"function"==typeof Gt(e)&&"function"==typeof e.max&&"function"==typeof e.min&&"function"==typeof e.off&&"function"==typeof e.on&&"function"==typeof e.remove&&"function"==typeof e.setOptions&&"function"==typeof e.stream&&"function"==typeof e.update&&"function"==typeof e.updateOnly}t.DELETE=Pi,t.DataSet=ku,t.DataStream=bu,t.DataView=Pu,t.Queue=vu,t.createNewDataPipeFrom=function(t){return new ye(t)},t.isDataSetLike=Iu,t.isDataViewLike=function(t,e){return"object"===yi(e)&&null!==e&&t===e.idProp&&"function"==typeof mo(e)&&"function"==typeof e.get&&"function"==typeof e.getDataSet&&"function"==typeof e.getIds&&"number"==typeof e.length&&"function"==typeof Gt(e)&&"function"==typeof e.off&&"function"==typeof e.on&&"function"==typeof e.stream&&Iu(t,e.getDataSet())},Object.defineProperty(t,"__esModule",{value:!0})}));
//# sourceMappingURL=vis-data.min.js.map
